*** Multipipsa ** Python wrapper for                         ***
*** Protein Interaction Property Similarity Analysis - PIPSA *** 

Date:      April, 2019
Authors:   Stefan Richter, Neil Bruce, Rebecca Wade
Copyright: HITS gGmbH, Schloss-Wolfsbrunnenweg 35c, 69118 Heidelberg 
           www.h-its.org
Contact:   mcmsoft@h-its.org
License:   EUPL (https://eupl.eu/1.2/en) 
           according to the LICENSE.EUPL file included in the distribution

THE LICENSE IS ACCEPTED BY USING THE SOFTWARE

The original PIPSA code is included in this distribution in the 
multipipsa/data/pipsa/ directory. This distribution has its own 
Copyright, License and Authorship information. By using this software,
you also agree to the license given in the multipipsa/data/pipsa/LICENSE
file.

Citation:  By using this software, you agree to cite the following references 
when publishing results obtained by the software:

Any application of PIPSA should cite the original papers:

Blomberg, N., Gabdoulline,R.R., Nilges, M., Wade,R.C. Classification of protein
sequences by homology modeling and quantitative analysis of electrostatic 
similarity. Proteins (1999) 37, 379-387.
Wade,R.C., Gabdoulline,R.R., De Rienzo, F.  
Protein Interaction Property Similarity
Analysis Intl. J. Quant. Chem. (2001) 83, 122-127.

Any application of webPIPSA should also cite:

Richter S, Wenzel A, Stein M, Gabdoulline RR, Wade RC. 
webPIPSA: a web server for the comparison of protein interaction properties. 
Nucleic Acids Res. 2008 Jul 1;36(Web Server issue):
W276-80. doi: 10.1093/nar/gkn181.

Any application of PIPSA for comparative analysis of the binding properties of 
user-defined groups of proteins using "multipipsa", should also cite:

Tong R, Wade RC, Bruce NJ. Comparative electrostatic analysis of adenylyl
cyclase for isoform dependent regulation properties. Proteins. 2016
Dec;84(12):1844-1858. doi: 10.1002/prot.25167.



This distribution of PIPSA 4.0 contains the standard PIPSA (ver. 3.2) code for 
running a PIPSA similiarity analysis on the whole protein skin or on selected 
parts of the protein skin (selected spheres, cones or cylinders) and in 
addition  has a python module for running several PIPSA runs on a single 
protein and comparing these with statistical measures.

The standard PIPSA distribution is located in the "pipsa" subdirectory. It is 
distributed with all the documentation, which is also found online:
https://projects.h-its.org/mcmsoft/pipsa/latest/usrguide.html
This version of PIPSA can also be run online using a webserver:
http://pipsa.h-its.org

In addition, this PIPSA distribution allows the user to run PIPSA within python
and to do a PIPSA analysis of the whole protein skin or on spheres centered on 
many points selected by the user, eg. all C-alpha carbon atoms. An image of the 
clustering is produced for each region analysed. Also one can compare clusters 
to a given reference cluster and write a PDB file with the scores in the 
B-Factor column of the PDB file.

The method described in [1] can also be run using the python modules. It 
reproduces the Fig. 5 of the reference. 
This method allows the comparative analysis of the molecular electrostatic 
potentials of two preselected groups of protein isoforms in order to obtain  
information on binding properties. The scores defined in [1] are written to 
the B-Factor column of the PDB file and can be visualized with any molecular 
viewer capable of coloring by B-Factor.

An example of how to use the python module is given in 
multipipsa/testMultipipsa.py and in the main method of the module file: 
multipipsa/multipipsa.py.
This script runs for approximately 15-20 minutes on a workstation.

A description of how to install PIPSA is given in the "pipsa" subdirectory.
The python module installation is described in the INSTALL file.

[1] Tong, Wade and Bruce, Proteins 2016; 84:1844-1858

addlinks.pl                  Adds a link before every line that has '(.*) show' in a .ps file. Basically, this program adds kewl code to the .ps files, so that when they are converted to .pdf 
files, one gets kewl links.
delphi2uhbd4linux            converts Delphi binary output grid to uhbd ascii format grid.  Precompiled version assumes grids computed unde SGI Irix.
delphi2uhbd.f
do_pipsa_UHBD2APBS           pipsa 2.0 script to compare UHBD grids and APBS grids (supposes that grids have the same spacing and origin and size)
do_pipsa_uho2pqr             Script to convert UHBD output to pqr
getnames.sh                  Downloads names, long names, gene definitions from the SWISS-PROT database for the proteins
grid2insight                 Converts GRID/UHBD format grid file to InsightII readable file
grid2insight.f
gridinfo                     Gets information from the UHBD grid
gridinfo.f
highlight_kin_groups         Highlights different groups of proteins in different colours
highlight_kin_groups.f
highlight_kin_points         Highlights proteins in red
highlight_kin_points.f
insightII.HydrSurface.in     Infile for the InsightII used to produce Hydrophobic Surfaces in .wrl 
insightII.electSurface.in    Infile for the InsightII used to produce Electrostatic Surfaces in .wrl
malign3d.2.sh                Aligns the sequences to the TEMPLATE.pdb sequence, using modeller and modeller.2.in script
malign3d.pl                  Runs modeller 6 to create 3D multiple alignment of all the proteins in pdbs directory
malign3d.sh                  Aligns the sequences to the TEMPLATE.pdb sequence, using whatif
malign3d.whatif.in           Script used by malign3d.sh
mkElecSurface.sh             Creates .wrl files that represent electrostatic surfaces. UHBD calculations should be done before the script is executed.
mkHydrSurface.sh             Creates .wrl files that represent hydrophobic surfaces. GRID calculatoins should be done before the script is executed.
mktree.sh                    Creates the tree from the similarity matrix - prototype to do_pipsa_phylip
modeller.2.in                Script used by the modeller 4 in malign3d.2.sh program
orient.sh                    Alignning the proteins using ORIENT command from the modeller. _very_ inaccurate
pqr2qcd                      Converts PQR format to UHBD readable QCD format
pqr2qcd.f
uho2pqr                      Converts UHBD output to pqr
uho2pqr.f

# Not the part of distribution
# create directory wrk_dir, with UHBD readable pdb files in its 
# pdbs/ subdirectory, place pdb file name list to the file "pdbnames" there

./do_pipsa_UHBD_prep /home/ra/gabdoull/wrk/pipsa/ /home/ra/gabdoull/wrk/pipsa/PH/ 

# this will generate /home/ra/gabdoull/wrk/pipsa/PH/uhbd/ 
# use pdb file names from /home/ra/gabdoull/wrk/pipsa/PH/pdbs/pdbnames
# and generate the files needed for uhbd calculations ("names" with protein names, and uhbd.in)

./do_pipsa_UHBD_chk /home/ra/gabdoull/wrk/pipsa/ /home/ra/gabdoull/wrk/pipsa/PH/uhbd /home/ra/gabdoull/wrk/pipsa/bin/uhbd
./do_pipsa_UHBD_grids /home/ra/gabdoull/wrk/pipsa/ /home/ra/gabdoull/wrk/pipsa/PH/uhbd /home/ra/gabdoull/wrk/pipsa/bin/uhbd

# this will compute elec potentials in  /home/ra/gabdoull/wrk/pipsa/PH/uhbd/
# calculate similarity matrix and derivatives for grids in  /home/ra/gabdoull/wrk/pipsa/PH/uhbd/:

./do_pipsa_sim /home/ra/gabdoull/wrk/pipsa/ /home/ra/gabdoull/wrk/pipsa/PH/uhbd/

# phylip diagrams can be generated using the script 

./do_pipsa_phylip /home/ra/gabdoull/wrk/pipsa/ /home/ra/gabdoull/wrk/pipsa/PH/uhbd/ /home/ra/gabdoull/wrk/pipsa_add/phylip/


./do_pipsa_UHBD_prep /home/ra/gabdoull/wrk/pipsa/ /home/ra/gabdoull/wrk/pipsa/WW
./do_pipsa_APBS_prep /home/ra/gabdoull/wrk/pipsa/ /home/ra/gabdoull/wrk/pipsa/WW
./do_pipsa_UHBD_chk /home/ra/gabdoull/wrk/pipsa/ /home/ra/gabdoull/wrk/pipsa/WW/uhbd /home/ra/gabdoull/wrk/pipsa/bin/uhbd
./do_pipsa_UHBD_grids /home/ra/gabdoull/wrk/pipsa/ /home/ra/gabdoull/wrk/pipsa/WW/uhbd /home/ra/gabdoull/wrk/pipsa/bin/uhbd
./do_pipsa_APBS_grids  /home/ra/gabdoull/wrk/pipsa/  /home/ra/gabdoull/wrk/pipsa/WW/apbs/ /home/ra/gabdoull/progs/apbs/bin/i686-pc-linux/apbs 
./do_pipsa_sim /home/ra/gabdoull/wrk/pipsa/ /home/ra/gabdoull/wrk/pipsa/WW/uhbd/
./do_pipsa_sim /home/ra/gabdoull/wrk/pipsa/ /home/ra/gabdoull/wrk/pipsa/WW/apbs/

./do_pipsa_UHBD_prep /home/ra/gabdoull/wrk/pipsa/ /home/ra/gabdoull/wrk/pipsa/PH
./do_pipsa_APBS_prep /home/ra/gabdoull/wrk/pipsa/ /home/ra/gabdoull/wrk/pipsa/PH
./do_pipsa_UHBD_chk /home/ra/gabdoull/wrk/pipsa/ /home/ra/gabdoull/wrk/pipsa/PH/uhbd /home/ra/gabdoull/wrk/pipsa/bin/uhbd
./do_pipsa_UHBD_grids /home/ra/gabdoull/wrk/pipsa/ /home/ra/gabdoull/wrk/pipsa/PH/uhbd /home/ra/gabdoull/wrk/pipsa/bin/uhbd
./do_pipsa_APBS_grids  /home/ra/gabdoull/wrk/pipsa/  /home/ra/gabdoull/wrk/pipsa/PH/apbs/ /home/ra/gabdoull/progs/apbs/bin/i686-pc-linux/apbs 
./do_pipsa_sim /home/ra/gabdoull/wrk/pipsa/ /home/ra/gabdoull/wrk/pipsa/PH/uhbd/
./do_pipsa_sim /home/ra/gabdoull/wrk/pipsa/ /home/ra/gabdoull/wrk/pipsa/PH/apbs

./do_pipsa_APBS_grids  /home/ra/gabdoull/wrk/pipsa/ /home/ra/gabdoull/wrk/pipsa/WW/apbs/ /home/ra/gabdoull/progs/apbs/bin/i686-pc-linux/apbs 
./do_pipsa_UHBD_grids  /home/ra/gabdoull/wrk/pipsa/ /home/ra/gabdoull/wrk/pipsa/WW/uhbd/ /home/ra/gabdoull/wrk/pipsa/bin/uhbd
./do_pipsa_sim /home/ra/gabdoull/wrk/pipsa/ /home/ra/gabdoull/wrk/pipsa/WW/apbs/
./do_pipsa_sim /home/ra/gabdoull/wrk/pipsa/ /home/ra/gabdoull/wrk/pipsa/WW/uhbd/
./do_pipsa_sim /home/ra/gabdoull/wrk/pipsa/ /home/ra/gabdoull/wrk/pipsa/WW/grid/

Each directory here has  9 PH domain coordinate files and 
the list of files in pdbnames.

opdbs/ - original pdb files produced by Modeller 
gpdbs/ - pdb files readable by GRID (here equivalent to opdbs/)
pdbs/  - pdb files readable by UHBD with polar hydrogens
pqrs/  - coordinates in PQR format readable by APBS

c----------------------------------------------------------------------
c  program 2potsim_skin_spheres
c  PIPSA version 3.0 (January 2007)         
c
c  Authors: R.R.Gabdoulline, R.C.Wade
c  Copyright (c) 2004
c  EML Research gGmbH, Schloss-Wolfsbrunnenweg 33, 69118 Heidelberg,
c  Germany, and
c  European Molecular Biology Laboratory, Heidelberg, Germany
c
c  This copyright notice must be attached to all copies, or extracts,
c  of this software.
c
c  Please obtain a license before using this software from the PIPSA
c  website or "rebecca.wade@eml-r.villa-bosch.de".
c  Conditions of usage are as specified in the license agreement.
c
c  Queries about problems with this software should be addressed to
c  "razif.gabdoulline@eml-r.villa-bosch.de".
c
c  References:
c  N. Blomberg, R.R. Gabdoulline, M. Nilges and R. C. Wade.
c   Classification of protein sequences by homology modeling and
c   quantitative analysis of electrostatic similarity.
c   Proteins: Str., Function and Genetics, 37:379-387 (1999)
c  Wade,R.C., Gabdoulline, R.R. and De Rienzo, F.
c   Protein Interaction Property Similarity Analysis
c   Intl. J. Quant. Chem., 83:122-127 (2001).
c----------------------------------------------------------------------
c
      include "maxdim.inc"
CccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccC
c
c Computes similarity of 2 potential grids on the molecular skin
c and around the specified point
c
c Input:
c - command line arg -g1 - the name of the file with potential grid for protein 1 
c   in UHBD format, default grd1.grd
c - command line arg -g2 - the name of the file with potential grid for protein 2
c   in UHBD format, default grd2.grd
c - command line arg -p1 - the name of the file with atom coordinates of protein 1
c   in PDB format, default pdb1.pdb
c - command line arg -p2 - the name of the file with atom coordinates of protein 2
c   in PDB format, default pdb2.pdb
c  - command line arg -pa - the name of the file with the list of directions
c   default name "spheres" - a list of (up to 99) sphere center coordinates and radii
c   to define the region where similarity is calculated
c   format of the file "spheres" is: xsc,radius where xsc is 3 coordinates 
c   (in &Aring;) of the sphere center and radius is the value of its radius
c - command line arg -pr - probe radius, default is 3 A
c - command line arg -sk - skin thickness, default is 4 A
c + default values are used if no input given
c
c The program will construct 2 skins (for protein 1 and 2) having thickness
c "skin" and at distance "probes" from van der Waals surface of the proteins.
c (i.e. from "probes" to "probes+skin" distance), using the points of the
c potential grids.  The potential values outside this skin will never be used.
c The followings will be computed:
c np1  = no of points of the skin of the protein 1
c np2  = no of points of the skin of the protein 2
c npoi = no of points of the intersecion of 2 skins
c aa0  = square of the norm of the grid 1 on its skin
c aa   = square of the norm of the grid 1 on intersection of the skins
c bb0  = square of the norm of the grid 2 on its skin
c bb   = square of the norm of the grid 2 on intersection of the skins
c ab   = scalar product of 2 potentials (on intersection of skins)
c amb  = average difference of the electrostatic potentials a and b (a-b)/npoi
c ambl = log(sum[exp(a)]/sum[exp(b)])
c ambm = log(sum[exp(-a)]/sum[exp(-b)])
c
c  Output:
c - fort.66 - some info about constructed skins
c - fort.6 - standard output has following data in one line:
c
c   si_hodgkin = 2*ab/(aa+bb)
c   si_carbo   = ab/sqrt(aa*bb)
c   aa
c   bb
c   ab
c   aa0
c   bb0
c   si_hodgkin_shape = 2.*float(npoi)/float(np1+np2)
c   si_carbo_shape   = float(npoi)/sqrt(float(np1*np2))
c   np1
c   np2
c   npoi
c   amb
c   ambl
c   ambm
c + this info is printed for every sphere defined in the file "spheres"
c
CccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccC
c
c 20.01.2003 - corrected wrong calculation of np2 and bb0
c
CccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccC
      character*1024 fpdb1,fpdb2,fgrd1,fgrd2,arg,fspheres,fpdbvol
      integer iform
      integer im, jm, km
      dimension xsc(3,999),ar(999),rsc(3)
      dimension grid1(im3_max)
      dimension grid2(im3_max)
      integer*1 isk1(im_max,im_max,im_max)
      integer*1 isk2(im_max,im_max,im_max)
      integer*1 isk1a(im_max,im_max,im_max)
      integer*1 isk2a(im_max,im_max,im_max)
	  character*54 str
      LOGICAL dopdbvol
      common/writePDB/dopdbvol,ipdbvol
      common/ius/iulog
	  common/probc/probes,skin
c
	  iupdb=8
	  iugrd=10
      iuparam=88
      iusphere=77
      iulog=66
      ipdbvol=99
      dopdbvol=.FALSE.
c
c. hard coded here change if need
      fpdb1='pdb1.pdb'
      fpdb2='pdb2.pdb'
      iform=0
      fgrd1='grd1.grd'
      fgrd2='grd2.grd'
      fspheres='spheres'
      probes=3.0
      skin=4.0
c
      call getarg(1,arg) 
      if(arg(1:2).eq.'-h') then
      write(6,499)
 499  format('usage: 2potsim_skin_spheres -g1 grd1.grd -g2 grd2.grd ',
     ,'-p1 pdb1.pdb -p2 pdb2.pdb -pv pdbvol.pdb -pa spheres -pr probe',
     ,' -sk skin')
      call exit
      end if
c
      nargs=iargc()
      do ia=1,nargs-1
      call getarg(ia,arg)
      if(arg(1:3).eq.'-g1') then
      call getarg(ia+1,fgrd1)
      end if
      if(arg(1:3).eq.'-g2') then
      call getarg(ia+1,fgrd2)
      end if
      if(arg(1:3).eq.'-p1') then
      call getarg(ia+1,fpdb1)
      end if
      if(arg(1:3).eq.'-p2') then
      call getarg(ia+1,fpdb2)
      end if
      if(arg(1:3).eq.'-pv') then
      call getarg(ia+1,fpdbvol)
      dopdbvol=.true.
      end if
      if(arg(1:3).eq.'-pa') then
      call getarg(ia+1,fspheres)
      end if
      if(arg(1:3).eq.'-pr') then
      call getarg(ia+1,arg)
      read(arg,*) probes
      end if
      if(arg(1:3).eq.'-sk') then
      call getarg(ia+1,arg)
      read(arg,*) skin
      end if
      end do
c
c begin code
c
      if (dopdbvol) then
       open(ipdbvol,FILE=fpdbvol,position='APPEND')
      end if
       open(iusphere,file=fspheres)
       nsphere=0
 71    continue
       read(iusphere,*,end=72,err=72) rsc,arr
       nsphere=nsphere+1
       ar(nsphere)=arr
        do m=1,3
        xsc(m,nsphere)=rsc(m)
        end do
        goto 71
 72     continue
        close(iusphere)
        write(iulog,*) 'will work on',nsphere,'  spheres'
c
c read the 3D grid
c
	  write(iulog,*)
	  write(iulog,*) 'Grid 1 file reading now... wait...'
      call inpgrd(fgrd1,iugrd,iform,im,jm,km,
     &             h,xo,yo,zo,grid1)
	  write(iulog,611) im,jm,km,h,xo,yo,zo
c
      call  mkskin(ifpdb,fpdb1,im,jm,km,h,xo,yo,zo,np1,isk1)
c
	  write(iulog,*)
	  write(iulog,*) 'Grid 2 file reading now... wait...'
      call inpgrd(fgrd2,iugrd,iform,im,jm,km,
     &             h,xo,yo,zo,grid2)
	  write(iulog,611) im,jm,km,h,xo,yo,zo
c
      call  mkskin(ifpdb,fpdb2,im,jm,km,h,xo,yo,zo,np2,isk2)
c
cc U-option
      if(nsphere.eq.0) then
      call rearra(grid1,grid2,im,jm,km,h,
     &                  xo,yo,zo,isk1,isk2,np1a,np2a,
     &                  npoi,aa,bb,ab,aa0,bb0,amb,ambl,ambm)
          write(iulog,611) im,jm,km,h,xo,yo,zo
          write(iulog,*) 'No of points on skin:',npoi
       pnp12=float(np1a)*float(np2a)
       write(6,612) 2*ab/(aa+bb),ab/sqrt(aa*bb),aa,bb,ab,aa0,bb0
     ,,2.*float(npoi)/float(np1a+np2a)
     ,,float(npoi)/sqrt(pnp12),np1a,np2a,npoi,amb,ambl,ambm
      call exit
      end if 
cc U-option
                DO isphere=1,nsphere
      do 421 i=1,im   
      do 422 j=1,jm   
      do 423 k=1,km   
      isk1a(i,j,k)=isk1(i,j,k)
      isk2a(i,j,k)=isk2(i,j,k)
 423  continue
 422  continue
 421  continue
                 do m=1,3
                 rsc(m)=xsc(m,isphere)
                 end do
                 scarr  = ar(isphere)**2
                 write(iulog,'(7f8.3)') rsc,scarr
 609  format(a ,a,' ',a)
 610  format(a)
       if (dopdbvol) then
       write(ipdbvol,609) 'HEADER',TRIM(fpdb1),TRIM(fpdb2)
c       write(ipdbvol,609),'MODEL',TRIM(fpdb1),TRIM(fpdb2)
      end if
               call rebuild(im,jm,km,h,xo,yo,zo,
     ,          rsc,scarr,isk1a,isk2a)
      call rearra(grid1,grid2,im,jm,km,h,
     &                  xo,yo,zo,isk1a,isk2a,np1a,np2a,
     &                  npoi,aa,bb,ab,aa0,bb0,amb,ambl,ambm)
	  write(iulog,611) im,jm,km,h,xo,yo,zo
	  write(iulog,*) 'No of points on skin:',npoi
 611  format('grid dimensions:  ',i3,2('.',i3),'  spacing:',f8.3,/,
     ,'grid origin:',3f8.3)
       pnp12=float(np1a)*float(np2a)
       write(6,612) 2*ab/(aa+bb),ab/sqrt(aa*bb),aa,bb,ab,aa0,bb0
     ,,2.*float(npoi)/float(np1a+np2a)
     ,,float(npoi)/sqrt(pnp12),np1a,np2a,npoi,amb,ambl,ambm
                 END DO
 612  format(2f7.3,5e15.7,2f7.3,3i7,5e15.7)
c
 1000  continue
      stop
   79 format(6e15.5)
   80 format(e15.5)
   81 format(3f8.2)
   83 format(10f8.3)
c
      end
      subroutine rearra(grid1,grid2,im,jm,km,h,
     &                  xo,yo,zo,isk1,isk2,np1a,np2a,
     &                  npoi,aa,bb,ab,aa0,bb0,amb,ambl,ambm)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      include "maxdim.inc"
      integer im, jm, km
	  integer*1 isk1(im_max,im_max,im_max)
	  integer*1 isk2(im_max,im_max,im_max)
      dimension grid1(1)
      dimension grid2(1)
      double precision daa,dbb,dab
      double precision daa0,dbb0,damb,dambla,damblb
      double precision dambma,dambmb
      common/ius/iulog
c
              write(iulog,81) xo, yo, zo
   81 format('rearrangement routine, grid origin:',3f8.3)
c
c ijk transform to n as n=i+(j-1)*im+(k-1)*im*jm
      imjm=im*jm
	  npoi=0
	  np1a=0
	  np2a=0
	  g1max=-1.e+20
	  g1min= 1.e+20
	  g2max=-1.e+20
	  g2min= 1.e+20
       daa=0.d0
       dbb=0.d0
       dab=0.d0
       daa0=0.d0
       dbb0=0.d0
       damb=0.d0
       dambla=0.d0
       damblb=0.d0
       dambma=0.d0
       dambmb=0.d0
      do 421 i=1,im   
      do 422 j=1,jm   
      do 423 k=1,km   
      nn=i+(j-1)*im+(k-1)*imjm
      if(isk1(i,j,k).ne.0) then
        daa0=daa0+grid1(nn)**2
        np1a=np1a+1
      end if
      if(isk2(i,j,k).ne.0) then
         dbb0=dbb0+grid2(nn)**2
         np2a=np2a+1
      end if
      if(isk1(i,j,k).eq.0) goto 410
      if(isk2(i,j,k).eq.0) goto 410
      npoi=npoi+1
      daa=daa+grid1(nn)**2 
      dbb=dbb+grid2(nn)**2 
      dab=dab+grid1(nn)*grid2(nn)
      damb=damb+grid1(nn)-grid2(nn)
      dambla=dambla+exp(grid1(nn))
      damblb=damblb+exp(grid2(nn))
      dambma=dambma+exp(-grid1(nn))
      dambmb=dambmb+exp(-grid2(nn))
	  if(grid1(npoi).gt.g1max) g1max=grid1(nn)
	  if(grid1(npoi).lt.g1min) g1min=grid1(nn)
	  if(grid2(npoi).gt.g2max) g2max=grid2(nn)
	  if(grid2(npoi).lt.g2min) g2min=grid2(nn)
 410  continue
 423  continue
 422  continue
 421  continue
       aa=daa 
       bb=dbb 
       ab=dab 
       aa0=daa0
       bb0=dbb0
       amb=damb/dfloat(npoi)
       ambl=dlog(dambla/damblb)
       ambm=dlog(dambma/dambmb)
              write(iulog,82) g1min, g1max
              write(iulog,82) g2min, g2max
   82 format('rearrangement routine, grid minmax:',2e11.3)
      return
      end
      subroutine inpgrd( filnam,iounit,iform,im,jm,km,
     &                   h,ox,oy,oz,grid) 
      include "maxdim.inc"
c
c. This is essentially a copy from UHBD version 4.1
      character*1024 filnam
      integer iounit, iform
      character*72 title
      integer im, jm, km
	  dimension grid(1)
      integer grdflg
      integer stderr
      common/ius/iulog
c
      real dum2, dum3, dum4, dum5, dum6, dum7, dum8
      integer idum1, idum2, idum3, idum4, idum5, idum6, idum7
      integer i, j, k, l, kx
      real xbuf(im_max*im_max*2)
	  stderr=6
c
      if ( iform .eq. 0 ) then
         open(iounit, file=filnam, form='unformatted', status='old' )
         read(iounit) title, scale, dum2, idum1, idum2,
     &                idum3, idum4, idum5, im, jm, km,
     &                h, ox, oy, oz,
     &                dum3, dum4, dum5, dum6, dum7, dum8, idum6, idum7
         if ( im*jm .gt. im_max*im_max*2 ) then
            write(stderr,99001)
            stop
c???
c???
         endif
         if ( im*jm*km .gt. im3_max ) then
            write(stderr,99002)
            stop
         endif
         do  10  k = 1 , km
            read(iounit) kx, im, jm
            read(iounit) (xbuf(l), l = 1 , im*jm)
            do  9  l = 1 , im*jm
c              grid((k-1)*im*jm+l) = xbuf(l) / scale
               grid((k-1)*im*jm+l) = xbuf(l)        
    9       continue
   10    continue
         close(iounit)
      else if ( iform .eq. 1 ) then
         open( iounit, file=filnam, form='formatted', status='old' )
         read(iounit,77) title, scale, dum2, idum1, idum2,
     &                   idum3, idum4, idum5, im, jm, km,
     &                   h, ox, oy, oz,
     &                   dum3, dum4, dum5, dum6, dum7, dum8,
     &                   idum6, idum7
         if ( im*jm*km .gt. im3_max ) then
            write(stderr,99002)
            stop
         endif
         do  20  k = 1 , km
            read(iounit,78) kx, im, jm
            read(iounit,79) ( grid((k-1)*im*jm+l), l=1,im*jm )
   20    continue
         close(iounit)
      endif
      return
c
c..........
c
c               Format statements.
c
   77 format(a72/2e12.6,5i7/3i7,4e12.6/4e12.6/2e12.6,2i7)
   78 format(3i7)
   79 format( (6(1x,e12.6)) )
99001 format(1x,'FATAL: inpgrd(001) buffer too small.' )
99002 format(1x,'FATAL: inpgrd(002) grid too large. ',
     .          'recompile with larger im_max value.' )
      end
	  subroutine mkskin(ifpdb,fpdb,im,jm,km,h,xo,yo,zo,npp,isk)
      include "maxdim.inc"
      character*80 string
	  character*1024 fpdb
	  character*4 atom
	  character*1 an
	  dimension xv(3)
	  character*1 iexsk(im_max),chex,chsk,chsp
c. this array is an internal
	  integer*1 iex(im_max,im_max,im_max)
c. this is supposed to be used later
	  integer*1 isk(im_max,im_max,im_max)
      common/ius/iulog
	  common/probc/probes,skin
	  data atom /'ATOM'/,chex,chsk,chsp/' ','x',' '/
c---
c
      do 301 i=1,im_max
      do 302 j=1,im_max
      do 303 k=1,im_max
      iex(i,j,k)=0
      isk(i,j,k)=0
 303  continue
 302  continue
 301  continue
c
	  write(iulog,*)
	  write(iulog,*) 'Constructing fitting region...'
      open(ifpdb,file=fpdb,form='formatted',status='old')
      dexcl=h
	  rexmax=1.9d0+probes
      hdexcl=dexcl/2.d0
      klim=(rexmax+dexcl*1.5d0)/dexcl
c		xexh=xo-hdexcl
c		yexh=yo-hdexcl
c		zexh=zo-hdexcl
		xexh=xo
		yexh=yo
		zexh=zo
c---find the center of the protein 
      natoms=0
	  npoi=0
 1    continue
	  read(ifpdb,500,end=99) string
	  if(string(1:4).ne.atom) goto 1
      read(string(1:54),501) an,xv
 500  format(a)
 501  format(13X,A1,16X,3F8.3)
      natoms=natoms+1
        call van(an,probes,rexcl2)
        rexcl=sqrt(rexcl2)
        x1=xv(1)
        x1a=x1+hdexcl  
        x2=xv(2)
        x2a=x2+hdexcl  
        x3=xv(3)
        x3a=x3+hdexcl  
C          FIND HOME GRID CELL IH,JH,KH
        ih=(x1a-xo)/dexcl
		jh=(x2a-yo)/dexcl
		kh=(x3a-zo)/dexcl
C
        DO 423 KK=-KLIM,KLIM
        K=KK+KH
        IF(k.le.0.or.k.gt.km)GOTO 423
c..here and further we correct the shifting by hdexcl:
c        ZK=dfloat(K)*dexcl-hdexcl+zo
c..here is a concerted change with change in exchk.f
        ZK=dfloat(K)*dexcl+zo
        ZTEMP = ZK - X3
        IF(ZTEMP.GT.rexcl)GOTO 423
                DO 422 JJ=-KLIM,KLIM
                J=JJ+JH
                IF(j.le.0.or.j.gt.jm)GOTO 422
                YJ=dFLOAT(J)*dexcl +yo
                YTEMP = YJ - X2
                IF(YTEMP.GT.rexcl)GOTO 422
                        DO 421 II=-KLIM,KLIM
                        I=II+IH
                        IF(i.le.0.or.i.gt.im)GOTO 421
                        IF(IEX(I,J,K).EQ.1)GOTO 421
                        XI=dFLOAT(I)*dexcl +xo
                        XTEMP = XI - X1
                        DIST2 =
     &                  XTEMP * XTEMP + YTEMP * YTEMP + ZTEMP * ZTEMP
                        IF(DIST2.GT.rexcl2)GOTO 421
                        IEX(I,J,K)=1
						npoi=npoi+1
 421                    CONTINUE
 422            CONTINUE
 423    CONTINUE
      goto 1
 99   continue
CCC      CLOSE(UNIT=iusas)
	  dismx1=sqrt(dismx1)
	  write(iulog,602) natoms,npoi
 602  format('No of atoms used for excl grid       :',i6,/,
     ,       'No of points assigned value 1        :',i6)
CCC
CCC__version 2.23__ repeat now the same with increased by skin probe
      dexcl=h   
	  probsk=probes+skin
c..the first number is the maximal atom radius appearing in pdb
	  rexmax=1.9d0+probsk        
      hdexcl=dexcl/2.d0
      klim=(rexmax+dexcl*1.5d0)/dexcl
CCC..skip the center finding 
c---read pdb file
      rewind (ifpdb)
      natosk=0
	  npoisk=0
 11   continue
	  read(ifpdb,500,end=991) string
	  if(string(1:4).ne.atom) goto 11
      read(string(1:54),501) an,xv
      natosk=natosk+1
        call van(an,probsk,rexcl2)
        rexcl=sqrt(rexcl2)
        x1=xv(1)
        x1a=x1+hdexcl  
        x2=xv(2)
        x2a=x2+hdexcl  
        x3=xv(3)
        x3a=x3+hdexcl  
C          FIND HOME GRID CELL IH,JH,KH
        ih=(x1a-xo)/dexcl
		jh=(x2a-yo)/dexcl
		kh=(x3a-zo)/dexcl
C
        DO 4231 KK=-KLIM,KLIM
        K=KK+KH
        IF(k.le.0.or.k.gt.km)GOTO 4231
c..here and further we correct the shifting by hdexcl:
c        ZK=dfloat(K)*dexcl-hdexcl+oez
c..here is a concerted change with change in exchk.f
        ZK=dfloat(K)*dexcl+ zo
        ZTEMP = ZK - X3
        IF(ZTEMP.GT.rexcl)GOTO 4231
                DO 4221 JJ=-KLIM,KLIM
                J=JJ+JH
                IF(j.le.0.or.j.gt.jm)GOTO 4221
                YJ=dFLOAT(J)*dexcl + yo
                YTEMP = YJ - X2
                IF(YTEMP.GT.rexcl)GOTO 4221
                        DO 4211 II=-KLIM,KLIM
                        I=II+IH
                        IF(i.le.0.or.i.gt.im)GOTO 4211
                        IF(IEX(I,J,K).EQ.1)GOTO 4211
                        IF(ISK(I,J,K).EQ.1)GOTO 4211
                        XI=dFLOAT(I)*dexcl + xo
                        XTEMP = XI - X1
                        DIST2 =
     &                  XTEMP * XTEMP + YTEMP * YTEMP + ZTEMP * ZTEMP
                        IF(DIST2.GT.rexcl2)GOTO 4211
                        ISK(I,J,K)=1
						npoisk=npoisk+1
 4211                   CONTINUE
 4221           CONTINUE
 4231   CONTINUE
      goto 11
 991  continue
      CLOSE(UNIT=ifpdb)

	  write(iulog,6021) natosk,npoisk
      npp=npoisk
 6021 format('No of atoms used for prot 1 excl+skin grid:',i6,/,
     ,       'No of points assigned value 1             :',i6)
CCC__version 2.23__ repeat ends                                     
CCC
CCC...Now write the prot1 ptofile 
      WRITE(iulog,603)
 603  format('A cross section of excl. grid of pr. #1, xOy plane',/)
      K=km/2
	  jskip=(jm-78)/2
	  if(jskip.lt.0) jskip=0 
	  iskip=(im-78)/2
	  if(iskip.lt.0) iskip=0 
      DO J=jskip+1,jm-jskip
		do 12 i=1,im
        iexsk(i)=chsp
		if(isk(i,j,k).eq.1) iexsk(i)=chsk
		if(iex(i,j,k).eq.1) iexsk(i)=chex
 12     continue
      WRITE(iulog,13)(iexsk(i),i=iskip+1,im-iskip)
      CONTINUE
 13   FORMAT(80a1)  
      END DO
	  write(iulog,*)
      RETURN
      END
      subroutine van(a,srad,v)
      character*1 a
c..These are OPLS parameters used in UHBD
      V=1.9  !DEFAULT VDW RADIUS
      IF(A.EQ.'H')V=1.20
      IF(A.EQ.'E')V=1.200
      IF(A.EQ.'C')V=1.90
      IF(A.EQ.'N')V=1.625
      IF(A.EQ.'O')V=1.48
      IF(A.EQ.'P')V=1.90
      IF(A.EQ.'S')V=1.85
      IF(A.EQ.'F')V=0.64  !ASSUMES FE
      IF(A.EQ.'Z')V=1.38  !ASSUMES ZN
      IF(A.EQ.'B')V=1.95  !ASSUMES BR
      IF(A.EQ.'I')V=2.15
      V=V+SRAD  !ADD PROBE RADIUS
      V=V*V
      RETURN
      END
      subroutine rebuild(im,jm,km,h,xo,yo,zo,
     ,          xsc,scarr,isk1a,isk2a)
      include "maxdim.inc"
      integer im, jm, km
      integer*1 isk1a(im_max,im_max,im_max)
      integer*1 isk2a(im_max,im_max,im_max)
      dimension xsc(3)
      common/ius/iulog
      do 421 i=1,im   
      do 422 j=1,jm   
      do 423 k=1,km   
          if((isk1a(i,j,k).eq.0).and.
     ,       (isk2a(i,j,k).eq.0)) goto 410
          xx=i*h+xo
          yy=j*h+yo
          zz=k*h+zo
          scp=
     +(xx-xsc(1))**2+(yy-xsc(2))**2+(zz-xsc(3))**2
          if(scp.gt.scarr) then
          isk1a(i,j,k)=0
          isk2a(i,j,k)=0
          end if
 410  continue
 423  continue
 422  continue
 421  continue
      return
      end

c----------------------------------------------------------------------
c  program npotsim     
c  PIPSA version 2.0 beta (December 2004)
c
c  Authors: R.R.Gabdoulline, R.C.Wade
c  Copyright (c) 2004
c  EML Research gGmbH, Schloss-Wolfsbrunnenweg 33, 69118 Heidelberg,
c  Germany, and
c  European Molecular Biology Laboratory, Heidelberg, Germany
c
c  This copyright notice must be attached to all copies, or extracts,
c  of this software.
c
c  Please obtain a license before using this software from the PIPSA
c  website or "rebecca.wade@eml-r.villa-bosch.de".
c  Conditions of usage are as specified in the license agreement.
c
c  Queries about problems with this software should be addressed to
c  "razif.gabdoulline@eml-r.villa-bosch.de".
c
c  References:
c  N. Blomberg, R.R. Gabdoulline, M. Nilges and R. C. Wade.
c   Classification of protein sequences by homology modeling and
c   quantitative analysis of electrostatic similarity.
c   Proteins: Str., Function and Genetics, 37:379-387 (1999)
c  Wade,R.C., Gabdoulline, R.R. and De Rienzo, F.
c   Protein Interaction Property Similarity Analysis
c   Intl. J. Quant. Chem., 83:122-127 (2001).
c----------------------------------------------------------------------
c
c drives similarity index calculations with 2potsim*
c
c Input:
c - command line arg -pg - similarity calculation program name
c   2potsim_noskin, 2potsim_skin or 2potsim_skin_parts, 
c   default is ../bin/2potsim_noskin
c - command line arg -fp - the directory where pdb files are located, 
c   default is ../pdbs
c - command line arg -fn - the name of the file with the names of 
c   proteins, each of which should have corresponding PDB file in the 
c   directory from -fp (../pdbs/), and corresponding potential file in ./
c   default is "names"
c - command line arg -lg - the name of the similarity matrix file
c   default is "sims.log"
c - command line arg -pr - the value of probe radius
c   default is 3 A
c - command line arg -sk - the value of skin thickness
c   default is 4 A
c - command line arg -pa - the name of the file with the list of directions
c   default name "parts" - a list of directions and angles to define conical parts
c
c Note that the program implies that it is executed in the directory, where 
c grid files are located and expects pdb files to be located in ../pdbs/ subdirectory
c all grid files corresponding to protein names in the file "names" must have 
c extension .grd and all pdb files must have extension .pdb
c
      include "maxdim.inc"
      character*256 pname,fname,lname,fparts,fpdbs,arg
      character*512 command,dum
      character*1 s
      character*256 ns(nprmx)
      character*512 target
      character*20 sgrpcount
      integer nmkcmds=10000
      integer icmdcount=int(0)
      integer igrpcnt=int(0)
      integer ismake=int(0)
C      character*512 target(maxgrps)
c
      do i=1,512
      dum(i:i)=' '
      end do
c
      pname='../bin/2potsim_noskin'
      fpdbs='../pdbs'
      fname='names'
      lname='sims.log'
      probes=3.0
      skin=4.0
      fparts='parts'
      nargs=iargc()
c
      call getarg(1,arg) 
      if((arg(1:2).eq.'').or.(arg(1:2).eq.'-h')) then
      write(6,499)
 499  format('usage: npotsim -pr program -fn fname -lg lname ',
     ,'-pr probe -sk skin -pa parts [-ma size_of_commandgroups ',
     ,'(to generate makefile)]')
      call exit
      end if
      ismake=0
      do ia=1,nargs-1
      call getarg(ia,arg)
      if(arg(1:3).eq.'-pg') then
      call getarg(ia+1,pname)
      end if
      if(arg(1:3).eq.'-fp') then
      call getarg(ia+1,fpdbs)
      end if
      if(arg(1:3).eq.'-fn') then
      call getarg(ia+1,fname)
      end if
      if(arg(1:3).eq.'-lg') then
      call getarg(ia+1,lname)
      end if
      if(arg(1:3).eq.'-pr') then
      call getarg(ia+1,arg)
      read(arg,*) probes
      end if
      if(arg(1:3).eq.'-sk') then
      call getarg(ia+1,arg)
      read(arg,*) skin
      end if
      if(arg(1:3).eq.'-pa') then
      call getarg(ia+1,fparts)
      end if
      if(arg(1:3).eq.'-ma') then
      ismake=int(1)
      call getarg(ia+1,arg)
      read(arg,*) nmkcmds
      end if
      end do
c
      open(11,file=fname)
      np=0
 1    continue
      read(11,'(a)',end=91) arg
      if(arg(1:6).eq.'      ') goto 1
      np=np+1
      ns(np)=arg
      goto 1
 91   continue
      close(11)
c
      if(ismake.eq.1) then
      open(10,file="Makefile")
      open(9,file="Makefile.alltargets")
      agrpcnt=0
      write(10,506) "all: collect"
      write(10,506) "clean: "
      write(10,503) char(9),"rm *.log *.part collect"
      write(9,502) "collect:"
      else
      open(12,file=lname)
      write(12,'(1H#,i6)') np
      close(12)
      end if
      do i=1,np
      do j=1,i
c
      call slen(ns(i),li)
      call slen(ns(j),lj)
      if(ismake.eq.int(0)) then
      open(12,file=lname)
 121  continue
      read(12,'(a)',end=122) s
      goto 121
 122  continue
      write(12,'(a,1x,a)') ns(i)(1:li),ns(j)(1:lj)
      close(12)
      end if
c
      command=dum
      call slen(pname,lpg)
      call slen(lname,llg)
      call slen(fparts,lpa)
      call slen(fpdbs,lpdbs)
      if(ismake.eq.0)then
      write(command, 500) pname(1:lpg),ns(i)(1:li),ns(j)(1:lj),
     ,fpdbs(1:lpdbs),ns(i)(1:li),fpdbs(1:lpdbs),ns(j)(1:lj),
     ,fparts(1:lpa),probes,skin,lname(1:llg)
      call system(command)
      else
      if (mod(icmdcount,nmkcmds).eq.0) then
      write(sgrpcount,505) igrpcnt+1
      call llen20(sgrpcount,lgrp)
      write(target,501) sgrpcount(lgrp:20),".",lname(1:llg)
      call slen512(target,lta)
      write(10,503) target(1:lta),":"
      write(9,502) target(1:lta)
      igrpcnt = igrpcnt+1
      endif
      write(command, 510) pname(1:lpg),ns(i)(1:li),ns(j)(1:lj),
     ,fpdbs(1:lpdbs),ns(i)(1:li),fpdbs(1:lpdbs),ns(j)(1:lj),
     ,fparts(1:lpa),probes,skin,sgrpcount(lgrp:20),".",lname(1:llg),
     ,'.part'
      call slen512(command,lc)
      if (mod(icmdcount,nmkcmds).eq.0) then
      write(10,507) char(9),'@echo "',ns(i)(1:li),ns(j)(1:lj),'">',
     ,sgrpcount(lgrp:20),".",lname(1:llg),'.part'
      else
      write(10,507) char(9),'@echo "',ns(i)(1:li),ns(j)(1:lj),'">>',
     ,sgrpcount(lgrp:20),".",lname(1:llg),'.part'      
      end if
      write(10,503) char(9), command(1:lc)
      if ((mod(icmdcount+1,nmkcmds).eq.0).or.(j.eq.np)) then 
      write(10,504) char(9), "touch ",target
      end if
      icmdcount = icmdcount+1
      end if
      call slen512(command,lc)
      if(ismake.eq.0) then
      write(6,'(a)') command(1:lc)
      else
      incp=int(np*(np+1)/2)
      if ((mod(icmdcount,10000).eq.0).or.(icmdcount.eq.incp))then
      write(6,'(a,i9,a,i9,a)') 'wrote ',icmdcount,' of ',incp,
     ,' commands'
      end if
      end if
c
      end do
      end do
      if(ismake.eq.1) then
      write(10, 506) 'include Makefile.alltargets'
      close (10)
      write(9,*)
      write(9,508) char(9),'@echo "#',np,'" > ',lname(1:llg)
      write(9,501) char(9),
     ,'ls *.log.part|sort -n -t .|xargs cat >> ',lname(1:llg)
      write(9,503) char(9),"touch collect"
      close(9)
      end if
c
 500  format(a,' -g1 ',a,'.grd -g2 ',a,'.grd -p1 ',a,'/',a,
     ,'.pdb -p2 ',a,'/',a,'.pdb -pa ',a,' -pr ',f7.3,
     ,' -sk ',f7.3,' >> ',a)
 501  format(a,a,a)
 502  format(a,' ',$)
 503  format(a,a)
 504  format(a,a,a)
 505  format(i20)
 506  format(a)
 507  format(a,a,a,1x,a,a,a,a,a,a)
 508  format(a,a,i6,a,a)
 510  format(a,' -g1 ',a,'.grd -g2 ',a,'.grd -p1 ',a,'/',a,
     ,'.pdb -p2 ',a,'/',a,'.pdb -pa ',a,' -pr ',f7.3,
     ,' -sk ',f7.3,' >> ',a,a,a,a)
c
      call exit
      end  
c
      subroutine slen(arg,na)
      character*256 arg
      na=1
      do ia=2,253
      na=ia-1
      if(arg(ia:ia+3).eq.'    ') return
      end do 
      return
      end

      subroutine slen512(arg,na)
      character*512 arg
      do i=512,1,-1
      na=i
      if(arg(i:i).ne.' ') return
      end do 
      return
      end
      
      subroutine llen20(arg,na)
      character*20 arg
      do i=1,512
      na=i
      if(arg(i:i).ne.' ') return
      end do
      return
      end

c----------------------------------------------------------------------
c  program mkkin       
c  PIPSA version 3.0 (Jan 2007)          
c
c  Authors: R.R.Gabdoulline, R.C.Wade
c  Copyright (c) 2004
c  EML Research gGmbH, Schloss-Wolfsbrunnenweg 33, 69118 Heidelberg,
c  Germany, and
c  European Molecular Biology Laboratory, Heidelberg, Germany
c
c  This copyright notice must be attached to all copies, or extracts,
c  of this software.
c
c  Please obtain a license before using this software from the PIPSA
c  website or "rebecca.wade@eml-r.villa-bosch.de".
c  Conditions of usage are as specified in the license agreement.
c
c  Queries about problems with this software should be addressed to
c  "razif.gabdoulline@eml-r.villa-bosch.de".
c
c  References:
c  N. Blomberg, R.R. Gabdoulline, M. Nilges and R. C. Wade.
c   Classification of protein sequences by homology modeling and
c   quantitative analysis of electrostatic similarity.
c   Proteins: Str., Function and Genetics, 37:379-387 (1999)
c  Wade,R.C., Gabdoulline, R.R. and De Rienzo, F.
c   Protein Interaction Property Similarity Analysis
c   Intl. J. Quant. Chem., 83:122-127 (2001).
c----------------------------------------------------------------------
c
      implicit real*8 (a-h,o-z)
c. 
c.. the matrix of ab,aa,bb, converts this to d(ab)
c.. convert d(ab)'s to 3D coordinates and writes in
c.. kinemage format
c..
      include "maxdim.inc"
      dimension dab1(nprmx2),xx(3,nprmx)
      character*40 argument
      character*30 pname1(nprmx2),pnamer
      character*30 pnames(nprmx,nprmx),pnamew
      dimension dab(nprmx,nprmx)
      dimension dabn(nprmx,nprmx)
      dimension xav(3)
      real*8 dum2(2)
      real*8 ans1,ans
c        
      call getarg(1,argument)
      read(argument(1:40),'(i40)') inom
      call getarg(2,argument)
      read(argument(1:40),'(i40)') nnom
c      write(6,*) ' analysing part #', inom,' of',nnom
c
      read(5,'(1x,i6)',end=99) np
      is1=0
 1    continue
      read(5,'(a)',end=99) pnamer
        do iom=1,inom-1
        read(5,*)
        end do
      read(5,*,end=99) si_h,si_c,aa,bb,ab,aa0,bb0
        do iom=inom+1,nnom
        read(5,*)
        end do
      is1=is1+1
      pname1(is1)=pnamer
c. distance based on norms at the intersection of skins
c      dab1(is1)=dsqrt(aa+bb-2.d0*ab)
c. distance based on norms on the whole skins
c      dab1(is1)=dsqrt(aa0+bb0-2.d0*ab)
c. distance based on similarity index
      dab1(is1)=dsqrt(2.d0-2.d0*si_c)
      goto 1
 99   continue
c
c       write(6,*) ' matrix read'
c
       ns1=is1
       ns1c=(np*np+np)/2 
       ns=np 
       if(ns1c.ne.ns1) then
       write(6,*) ' bad matrix: expected',ns1c,'  points'
       write(6,*) 'got:', ns1,'  - please correct'
       goto 999
       end if
c
         fmax=0.0d0
         i1max=1
         i2max=2
       is1=0
       do i1=1,ns
       do i2=1,i1
c       is1=i1+(i2-1)*ns
       is1=is1+1
       dab(i1,i2)=dab1(is1)
       dab(i2,i1)=dab1(is1)
         if(dab(i1,i2).gt.fmax) then
         fmax=dab(i1,i2)
         i1max=i1
         i2max=i2
         end if
       pnames(i1,i2)=pname1(is1)
       end do 
       end do 
c
c       do i=1,10
c       write(6,'(10f7.2)') (dab(i,j),j=1,10)
c       end do
c
          do 1111 i1=1,ns   
          do 2111 i2=1,ns   
          dab(i1,i2)=dab(i1,i2)/fmax
 2111 continue
 1111 continue
c
          dmax=0.
      do 112 i3=1,ns   
          d13=dab(i1max,i3)
          d23=dab(i2max,i3)
          aa=0.5*(1+d13**2-d23**2)
          bb=dsqrt(d13**2-aa**2)
          d2=bb
          if(d2.gt.dmax) then
          dmax=d2
          i3max=i3
          a=aa
          b=bb
          end if
 112  continue
c
          dmax2=0.
      do 1121 i4=1,ns   
      d14=dab(i1max,i4)
      d24=dab(i2max,i4)
      d34=dab(i3max,i4)
          cc=0.5*(1+d14**2-d24**2)
      dd=0.5/b*(d14**2-d34**2-a*(2.*cc-a)+b**2)
          ee=dsqrt(d14**2-cc**2-dd**2)
          d2=ee
          if(d2.gt.dmax2) then
          dmax2=d2
          i4max=i4
          c=cc
          d=dd
          e=ee
          end if
 1121  continue
c
c. largest tetraedr found and a,b,c,d,e are known
          d12=dab(i1max,i2max)
          d13=dab(i1max,i3max)
          d14=dab(i1max,i4max)
          d23=dab(i2max,i3max)
          d24=dab(i2max,i4max)
          d34=dab(i3max,i4max)
c      write(6,500) i1max,i2max,i3max,i4max,
c     ,d12,d13,d14,d23,d24,d34
c      write(6,500) i1max,i2max,i3max,i4max,a,b,c,d,e
c 500  format('#',4i5,6f8.3)
c
c. all others are projected:
c
          xav(1)=0.
          xav(2)=0.
          xav(3)=0.
      do 50 ii=1,ns   
          d1=dab(i1max,ii)
          d2=dab(i2max,ii)
          d3=dab(i3max,ii)
          d4=dab(i4max,ii)
          x=(1.+d1**2-d2**2)/2.
          y=(b**2+d1**2-d3**2-a*(2*x-a))/2./b
          z=(d3**2-d4**2-(a-x)**2+(c-x)**2-
     -(b-y)**2+(d-y)**2+e**2)/2./e
          xx(1,ii)=x*fmax
          xx(2,ii)=y*fmax
          xx(3,ii)=z*fmax
          xav(1)=xav(1)+x*fmax
          xav(2)=xav(2)+y*fmax
          xav(3)=xav(3)+z*fmax
 50   continue
      xav(1)=xav(1)/float(ns)   
      xav(2)=xav(2)/float(ns)   
      xav(3)=xav(3)/float(ns)   
c      write(6,501) xav
c 501  format('#',6f8.3)
 502  format(i5,3f11.6) 
c
 999  continue
c
      lpnmx=0
      do i=1,ns
      pnamew=pnames(i,i)
      call namelength(pnamew,lpn)
      if(lpn.gt.lpnmx) lpnmx=lpn
      end do
c
      dmoo=0.d0
      dmnn=0.d0
      dmon=0.d0
      do i1=1,ns
      do i2=1,ns
      dmoo=dmoo+dab(i1,i2)*dab(i1,i2)
      d12=sqrt((xx(1,i1)-xx(1,i2))**2+
     +         (xx(2,i1)-xx(2,i2))**2+
     +         (xx(3,i1)-xx(3,i2))**2)
      dmnn=dmnn+d12*d12
      dmon=dmon+d12*dab(i1,i2) 
      end do
      end do
      accuracy=2.d0*dmon/(dmoo+dmnn)
c
      call wheader(accuracy,xav)
c
      do i=1,ns
      pnamew=pnames(i,i)
      call nameclear(pnamew) 
      write(6,601) i,pnamew(1:lpnmx),(xx(m,i),m=1,3)
      end do
c
 601  format('{',i3,1x,a,' }',3f8.3)
c
      call exit
      end 
c
      subroutine namelength(name,lpn)
      implicit real*8 (a-h,o-z)
      parameter (n30=30)
      character*30 name
      character*1 sp
      data sp/' '/
c
      ke=n30+1
      do k=1,n30
      if(name(k:k).eq.sp) then
      ke=k
      goto 41
      end if
      end do
 41   continue
      lpn=ke-1
      return
      end
      subroutine nameclear(name)
      implicit real*8 (a-h,o-z)
      parameter (n30=30)
      character*30 name
      character*1 sp
      data sp/' '/
c
      ke=n30+1
      do k=1,n30
      if(name(k:k).eq.sp) then
      ke=k
      goto 41
      end if
      end do
 41   continue
      do k=ke,n30
      name(k:k)=sp
      end do
      return
      end
      subroutine wheader(accuracy,xav)
      implicit real*8 (a-h,o-z)
      dimension xav(3)
c
      write(6,501) accuracy,xav
 501  format(
     1'@text',/,
     1'    Representation of the proteins as a points in 3D',/,
     1'based on similarities of their interaction fields.',/,
     1'    The distance between proteins i and j is defined as',/,
     1'D(i,j) = sqrt(2-2*SI(i,j)), where SI(i,j) is the',/, 
     1'similarity index of their interaction fields. Four',/, 
     1'points defining the 3D space were chosen as follows:',/,
     1'    a) The first two points (1 and 2) are chosen as',/, 
     1'those for which the distance D(1,2), is largest. This',/, 
     1'D(1,2) is then used for normalization of all other',/, 
     1'distances.',/,
     1'    b) Point 3 is chosen so that the area of the',/, 
     1'triangle formed by points 1,2 and 3 is the largest.',/,
     1'    c) Point 4 is chosen so that the volume of the',/,
     1'tetrahedron formed by points 1,2,3 and 4 is the largest.',/,
     1'    The 3D coordinates assigned to these 4 points are',/,
     1'(0,0,0), (1,0,0), (a,b,0), (c,d,e), where a, b, c, d',/, 
     1'and e are computed unambiguously from the 6 pairwise',/, 
     1'distances.  The other compounds are projected onto this',/, 
     1'defined 3D space with coordinates determined from their',/, 
     1'SI(i,j) values.',/,
     1'@kinemage 1',/,
     1'@caption',/,
     1'    Representation of the proteins as a points in 3D',/,
     1'based on similarities of their interaction fields.',/,
     1'(see MAGE Text)',/,
     1'    This representation is approximate and distorts',/, 
     1'original distance matrix.  Accuracy may be measured',/, 
     1'by similarity of the original matrix to the matrix',/, 
     1'derived from 3D distribution; Hodgkin index of this',/,
     1'similarity is : ',f8.3,/,  
     1'(more accurate means this index close to 1.000)',/,
     1'@onewidth',/,
     1'@matrix',/,
     1'1 0 0  0 1 0  0 0 1',/,
     1'@viewid {x y}',/,
     1'@2zoom 1.0',/,
     1'@2zslab 2',/,
     1'@2center',3f8.3,/,
     1'@2matrix',/,
     1'1 0 0   0 0 1  0 -1 0',/,
     1'@2viewid {x z}',/,
     1'@3zslab 2',/,
     1'@3matrix',/,
     1'0 0 1  0 1 0  -1 0 0',/,
     1'@3viewid {z y}',/,
     1'@group {ALL}',/,
     1'@balllist {ALL} color= white radius= 0.008'
     1)
c
      return
      end

c----------------------------------------------------------------------
c  program smNextopred
c  PIPSA version 3.0 (Jan 2007)
c
c  Authors: R.R.Gabdoulline, R.C.Wade
c  Copyright (c) 2004
c  EML Research gGmbH, Schloss-Wolfsbrunnenweg 33, 69118 Heidelberg,
c  Germany, and
c  European Molecular Biology Laboratory, Heidelberg, Germany
c
c  This copyright notice must be attached to all copies, or extracts,
c  of this software.
c
c  Please obtain a license before using this software from the PIPSA
c  website or "rebecca.wade@eml-r.villa-bosch.de".
c  Conditions of usage are as specified in the license agreement.
c
c  Queries about problems with this software should be addressed to
c  "razif.gabdoulline@eml-r.villa-bosch.de".
c
c  References:
c  N. Blomberg, R.R. Gabdoulline, M. Nilges and R. C. Wade.
c   Classification of protein sequences by homology modeling and
c   quantitative analysis of electrostatic similarity.
c   Proteins: Str., Function and Genetics, 37:379-387 (1999)
c  Wade,R.C., Gabdoulline, R.R. and De Rienzo, F.
c   Protein Interaction Property Similarity Analysis
c   Intl. J. Quant. Chem., 83:122-127 (2001).
c----------------------------------------------------------------------
c
c reads sims.log and exp data, derives regression from 
c known kinetic parameters (rate ratio vs ep difference)
c predicts unknown kinetic parameters
c  
c the protein names must be arranged the same way as in 
c the file "names" used to compute similarity matrix 
c and known parameters should be written on the line after 
c the protein name
c if no number after the protein name - then this parameter
c is assumed to be unknown and predicted
c
c this version aasumes sum(a-b) proportional to log(Ka/Kb)
c proportionality constant derived from known cases
c and used for predicting unknown cases
c
c Input
c - command line arg -fl - the name of pipsa similarity log file
c   default is sims.log
c - command line arg -fe - the name of the file with experimental data 
c   where in one line the protein name is followed by experimental data
c   when available and with nothing or 0.0 when needs to be predicted
c - command line arg -fo - the name of the output file with 
c   correlation between log(k1/k2) and    (ep1-ep2)         
c   default is smNex2cor.out
c - command line arg -fp - the name of the output file with 
c   all predictions for each case
c   default is smNextopred.pre
c - command line arg -sn - the ep difference measure to be used:
c   1 - difference of average ep : av(ep1)-av(ep2)
c   2 - log of ratio of exp(ep)  : log (sum(exp(ep1))/sum(exp(ep2)))
c   3 - log of ratio of exp(-ep) : log (sum(exp(-ep1))/sum(exp(-ep2)))
c   default is 1
c - command line arg -rc - user-defined correlation coefficient
c   default is define it correlating known cases
c   correlation is Drate = rc*Dpotential, 
c   i.e. how much rate changes by 1 kcal/mole change in potential
c 
c Output
c - Standard out - prediction results with errors
c
c
      character*256 flog,fexp,fout,fpre
      character*256 s,arg,pnams(99)
      dimension rt(99),sm1(99,99),sm2(99,99),sm3(99,99)
      dimension sm4(99,99),sm5(99,99),sm6(99,99),sm7(99,99)
      dimension drt(9999),s1msi1(9999),s1msi2(9999)
      dimension rt1m(99),rt2m(99),rt1p(99),rt2p(99)
      dimension rt1(2,99),rt2(2,99),rtpre(99)
      dimension rt11(99),rt12(99),rt21(99),rt22(99)
      dimension amb(3)
      integer known(99)
c
      flog='sims.log'
      fexp='exp'
      fout='smNextopred.out'
      fpre='smNextopred.pre'
      isn=1
c
      call getarg(1,arg) 
      if(arg(1:2).eq.'-h') then
      write(6,499)
 499  format('usage: smNextopred -fl sims.log -fe exp -fo ',
     ,        'smNextopred.out -fp smNextopred.pre',
     ,        ' -sn sim_data_num -rc regr_coef')
      call exit
      end if
c
      aa=0.0
      nargs=iargc()
      do ia=1,nargs-1
      call getarg(ia,arg)
      if(arg(1:3).eq.'-fl') then
      call getarg(ia+1,flog)
      end if
      if(arg(1:3).eq.'-fe') then
      call getarg(ia+1,fexp)
      end if
      if(arg(1:3).eq.'-fo') then
      call getarg(ia+1,fout)
      end if
      if(arg(1:3).eq.'-fp') then
      call getarg(ia+1,fpre)
      end if
      if(arg(1:3).eq.'-sn') then
      call getarg(ia+1,arg)
      read(arg,*) isn
      end if
      if(arg(1:3).eq.'-rc') then
      call getarg(ia+1,arg)
      read(arg,*) rc
      end if
      end do
c
      open(1,file=flog)
      read(1,'(1x,i6)') np
      do ip=1,np
      do jp=1,ip
      read(1,*)
c      read(1,*) sm1(ip,jp),sm2(ip,jp)
      read(1,612) sm1p,sm2p,aa,bb,ab,aa0,bb0,
     ,           sm1s,sm2s,np1,np2,npp,amb
      sm1(ip,jp)=amb(isn)
      sm1(jp,ip)=-sm1(ip,jp)
      end do
      end do
      close(1)
 612  format(2f7.3,5e15.7,2f7.3,3i7,3e15.7)
c
c. read exp and assign known=0 for unknown cases
c
      open(2,file=fexp)
      do ip=1,np
      read(2,'(a)') s
      pnams(ip)=s
      call sfsp(s,nfsp)
      rtt=0.0
      read(s(nfsp:256),*,end=100) rtt
 100  continue
      if(rtt.eq.0.) then
      known(ip)=0
      rt(ip)=0.0
      else
      known(ip)=1
      rt(ip)=alog(rtt)
      end if
      end do
      close(2)
c
c. write correlation for known cases
c
      open(3,file=fout)
      write(3,501)
      nreg=0
      do ip=1,np
      if(known(ip).eq.0) goto 302
      write(3,*)
       do jp=1,np
       if(known(jp).eq.0) goto 301
       nreg=nreg+1
       drt(nreg)=rt(ip)-rt(jp)
       s1msi1(nreg)=sm1(ip,jp)
       write(3,'(3f8.3)') drt(nreg),s1msi1(nreg)
 301   continue
       end do 
 302  continue
      end do 
      close(3)
 501  format('# log(k1)-log(k2)  ',
     ,       '  phi1 - phi2      ')
 5011 format('# pred(i)')
c
c. construct regression model
c
      if(rc.ne.0.0) then
      d1=0.0
      a1=rc
      goto 333
      end if
c
      sxy=0.0
      sxx=0.0
      syy=0.0
      do ireg=1,nreg
      sxy=sxy+drt(ireg)*s1msi1(ireg)
      sxx=sxx+s1msi1(ireg)*s1msi1(ireg)
      syy=syy+drt(ireg)*drt(ireg)
      end do
      a1=sxy/sxx 
      d1=(a1**2*sxx-2.0*a1*sxy+syy)/syy
 333  continue
      write(6,*) 'Coeff=',a1,'  Disp=',d1
c
c. predict: all possibilities and av w err
c
      open(4,file=fpre)
      do ip=1,np
      if(known(ip).ne.0) goto 402
      rti=0.0
      npre=0
        do jp=1,np
        if(known(jp).eq.0) goto 401
        npre=npre+1
        si1=sm1(ip,jp)      
        drt1=si1*a1
        rt1(1,npre)=rt(jp)+drt1
 401    continue
        end do 
c
        do 404 lp=1,npre
        rtpre(lp)=rt1(1,lp)     
 404    continue
        rtpred=0.0
          do 405 lp=1,npre
          rtpred=rtpred+rtpre(lp)
 405      continue
          rtpred=rtpred/float(npre)
          drtpred=0.0
          do 406 lp=1,npre
          drtpred=drtpred+(exp(rtpre(lp))-exp(rtpred))**2
 406      continue
          drtpred=sqrt(drtpred/float(npre))
c.  
      s=pnams(ip)
      call sfsp(s,nfsp)
      write(6,505) s(1:nfsp),ip,exp(rtpred),
     ,drtpred
      write(4,505) s(1:nfsp),ip,exp(rtpred),
     ,drtpred
c
 402  continue
      end do 
      close(4)
 505  format(a,i4,2e13.4,99e13.4)

c
      call exit
      end
      subroutine sfsp(s,nfsp)
      character*256 s
      do i=1,256
      nfsp=i
      if(s(i:i).eq.' ') return
      end do
      return 
      end
      subroutine slen(s,ns)
      character*256 s
      do i=256,1,-1
      ns=i
      if(s(i:i).ne.' ') return
      end do
      return 
      end

c----------------------------------------------------------------------
c  program n1potsim    
c  PIPSA version 3.0 (Jan 2007)          
c
c  Authors: R.R.Gabdoulline, R.C.Wade
c  Copyright (c) 2004
c  EML Research gGmbH, Schloss-Wolfsbrunnenweg 33, 69118 Heidelberg,
c  Germany, and
c  European Molecular Biology Laboratory, Heidelberg, Germany
c
c  This copyright notice must be attached to all copies, or extracts,
c  of this software.
c
c  Please obtain a license before using this software from the PIPSA
c  website or "rebecca.wade@eml-r.villa-bosch.de".
c  Conditions of usage are as specified in the license agreement.
c
c  Queries about problems with this software should be addressed to
c  "razif.gabdoulline@eml-r.villa-bosch.de".
c
c  References:
c  N. Blomberg, R.R. Gabdoulline, M. Nilges and R. C. Wade.
c   Classification of protein sequences by homology modeling and
c   quantitative analysis of electrostatic similarity.
c   Proteins: Str., Function and Genetics, 37:379-387 (1999)
c  Wade,R.C., Gabdoulline, R.R. and De Rienzo, F.
c   Protein Interaction Property Similarity Analysis
c   Intl. J. Quant. Chem., 83:122-127 (2001).
c----------------------------------------------------------------------
c
c Simple operation: removes a given protein from pipsa analysis.
c This is done by reading the protein's name, removing it from the 
c list (file "names") and from related to it similarity matrix ("sims.log")
c
c Input:
c - command line arg -fn - the name of the file with the names of 
c   original set of proteins, each of which should have corresponding 
c   PDB file in the directory ../pdbs/, and corresponding potential file in ./
c   default is "names"
c - command line arg -p1 - the name of the protein to be removed,
c   its potential in ./ and pdb file in ../pdbs are not removed
c   and not used.
c - command line arg -p  - the same as above 
c - command line arg -lg - the name of the similarity matrix file
c   default is "sims.log" - will be modified
c
c Note that 
c + the program implies that it is executed in the directory, where 
c   grid files are located and expects pdb files to be located in ../pdbs/ subdirectory
c + the file "names" after execution of this program will be renamed to "names-old" 
c   and a new file "names" will be created, which does not have the removed protein name
c + the old similarity matrix file will be renamed to "sims.log-old" and new file 
c    "sims.log" (or any other name given after -lg) sill be created which does not have 
c    all entries related to the removed protein anymore
c + note that the grid and pdb files will not be removed.  These need to
c    be either removed separately, or replaced by a new versions, if
c    subsequently a new version of a protein is supposed to be added
c
      include "maxdim.inc"
      character*256 pname,fname,lname,fparts,fpdbs,arg
      character*256 pnam1 pnam2
      character*512 command,dum
      character*256 fnameo,lnameo,nap1
      character*256 ns(nprmx)
      character*1 s
c
      do i=1,512
      dum(i:i)=' '
      end do
c
      pname='../bin/2potsim_noskin'
      fpdbs='../pdbs'
      fname='names'
      lname='sims.log'
      probes=3.0
      skin=4.0
      fparts='parts'
      nap1='      '
      nargs=iargc()
c
      call getarg(1,arg) 
      if(arg(1:2).eq.'-h') then
      write(6,499)
 499  format('usage: m1potsim -fn fname -lg lname ',
     ,'-p1 protein_name')
      call exit
      end if
      do ia=1,nargs-1
      call getarg(ia,arg)
      if(arg(1:3).eq.'-pg') then
      call getarg(ia+1,pname)
      end if
      if(arg(1:3).eq.'-fp') then
      call getarg(ia+1,fpdbs)
      end if
      if(arg(1:3).eq.'-fn') then
      call getarg(ia+1,fname)
      end if
      if(arg(1:3).eq.'-lg') then
      call getarg(ia+1,lname)
      end if
      if(arg(1:3).eq.'-pr') then
      call getarg(ia+1,arg)
      read(arg,*) probes
      end if
      if(arg(1:3).eq.'-sk') then
      call getarg(ia+1,arg)
      read(arg,*) skin
      end if
      if(arg(1:3).eq.'-pa') then
      call getarg(ia+1,fparts)
      end if
      if(arg(1:3).eq.'-p1') then
      call getarg(ia+1,nap1)
      end if
      end do
c
      open(11,file=fname)
      np=0
 1    continue
      read(11,'(a)',end=91) arg
      if(arg(1:6).eq.'      ') goto 1
      np=np+1
      ns(np)=arg
      goto 1
 91   continue
      close(11)
c
      open(12,file=lname)
      read(12,'(1x,i6)') npo
      close(12)
      if(npo.ne.np) then
      write(6,*) 'file with names says there were',np,'  proteins'
      write(6,*) 'file with sim matrix says there were',npo,'  proteins'
      write(6,*) 'please resolve the inconsistency first'
      call exit
      end if
      if(nap1.eq.'      ') then
      write(6,*) 'the name of the protein to remove from the set',
     ,' must be given'
      write(6,499)
      call exit
      end if
c
      call slen(fname,lfn)
      write(fnameo,701) fname(1:lfn)
      command=dum
      write(command,702)  fname(1:lfn), fname(1:lfn)
      call slen512(command,lc)
      write(6,'(a)') command(1:lc)
      call system(command)
      call slen(lname,lln)
      write(lnameo,701) lname(1:lln)
      write(command,702)  lname(1:lln), lname(1:lln)
      call slen512(command,lc)
      write(6,'(a)') command(1:lc)
      call system(command)
 701  format(a,'-old')
 702  format('mv -f ',a,' ',a,'-old')
 7021 format('mv -f ',a,'-old ',a)
c
      open(10,file=fnameo)
      open(11,file=fname)
      call slen(nap1,lnap1)
      nprem=0
 111  continue
      read(10,'(a)',end=94) arg
      call slen(arg,larg)
      if(nap1(1:lnap1).eq.arg(1:larg)) then
      nprem=nprem+1
      goto 111
      end if
      write(11,'(a)') arg(1:larg)
      goto 111
  94  continue
      close(10)
      close(11)
c
      if(nprem.eq.0) then
      command=dum
      write(command,7021)  fname(1:lfn), fname(1:lfn)
      call slen512(command,lc)
      write(6,'(a)') command(1:lc)
      call system(command)
      command=dum
      write(command,7021)  lname(1:lln), lname(1:lln)
      call slen512(command,lc)
      write(6,'(a)') command(1:lc)
      call system(command)
      write(6,*) 'a given protein is not found in ', 
     ,'the original set, therefore nothing changed'
      write(6,'(a)') nap1(1:lnap1) 
      goto 999
      end if
c
      open(13,file=lname)
      write(13,'(1H#,i6)') np-1
      open(12,file=lnameo)
      read(12,'(a)',end=95) arg
 112  continue
      read(12,'(a)',end=95) arg
      call get2str(arg,n1b,n1e,n2b,n2e)
c remove if the name is given
      if(arg(n1b:n1e).eq.nap1(1:lnap1)) then
      read(12,'(a)',end=95) arg
      goto 112
      end if
      if(arg(n2b:n2e).eq.nap1(1:lnap1)) then
      read(12,'(a)',end=95) arg
      goto 112
      end if
c leave as is if not given
      call slen(arg,la)
      write(13,'(a)') arg(1:la)
      read(12,'(a)',end=95) arg
      call slen(arg,la)
      write(13,'(a)') arg(1:la)
      goto 112
 95   continue
      close(12)
      close(13)
c
 999  continue
      call exit
      end  
c
      subroutine slen(arg,na)
      character*256 arg
      na=1
      do ia=2,249
      na=ia-1
      if(arg(ia:ia+7).eq.'        ') return
      end do 
      return
      end

      subroutine slen512(arg,na)
      character*512 arg
      do i=512,1,-1
      na=i
      if(arg(i:i).ne.' ') return
      end do
      return
      end

      subroutine get2str(arg,n1b,n1e,n2b,n2e)
      character*256 arg
      do i=1,256
      n1b=i
      if(arg(i:i).ne.' ') goto 11
      end do
 11   continue
      do i=n1b,256
      n1e=i-1
      if(arg(i:i).eq.' ') goto 12
      end do
 12   continue
      do i=n1e+1,256
      n2b=i
      if(arg(i:i).ne.' ') goto 21
      end do
 21   continue
      do i=n2b,256
      n2e=i-1
      if(arg(i:i).eq.' ') goto 22
      end do
 22   continue
      return
      end

c  program 2potsim_noskin
c  PIPSA version 3.0 (Jan 2007)          
c
c  Authors: R.R.Gabdoulline, R.C.Wade
c  Copyright (c) 2004
c  EML Research gGmbH, Schloss-Wolfsbrunnenweg 33, 69118 Heidelberg,
c  Germany, and
c  European Molecular Biology Laboratory, Heidelberg, Germany
c
c  This copyright notice must be attached to all copies, or extracts,
c  of this software.
c
c  Please obtain a license before using this software from the PIPSA
c  website or "rebecca.wade@eml-r.villa-bosch.de".
c  Conditions of usage are as specified in the license agreement.
c
c  Queries about problems with this software should be addressed to
c  "razif.gabdoulline@eml-r.villa-bosch.de".
c
c  References:
c  N. Blomberg, R.R. Gabdoulline, M. Nilges and R. C. Wade.
c   Classification of protein sequences by homology modeling and
c   quantitative analysis of electrostatic similarity.
c   Proteins: Str., Function and Genetics, 37:379-387 (1999)
c  Wade,R.C., Gabdoulline, R.R. and De Rienzo, F.
c   Protein Interaction Property Similarity Analysis
c   Intl. J. Quant. Chem., 83:122-127 (2001).

c----------------------------------------------------------------------
c
      include "maxdim.inc"
CccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccC
c
c Computes similarity of 2 potential grids on all points
c
c Input:
c - command line arg -g1 - the name of the file with potential grid for protein 1 
c   in UHBD format, default grd1.grd
c - command line arg -g2 - the name of the file with potential grid for protein 2 
c   in UHBD format, default grd2.grd
c
c The program will use the values of electrostatic potentials at 
c each point of the grids and derive the similarity index.
c The followings will be computed:
c aa   = square of the norm of the grid 1
c bb   = square of the norm of the grid 2
c ab   = scalar product of 2 potentials
c
c  Output:
c - fort.66 - some info about constructed skins
c - standard output (fort.6) has following data in one line:
c
c   si_hodgkin = 2*ab/(aa+bb)
c   si_carbo   = ab/sqrt(aa*bb)
c   aa
c   bb
c   ab
c
CccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccC
      integer iform
      character*256 fgrd1,fgrd2,arg
      integer im, jm, km
      dimension grd1(im3_max)
      dimension grd2(im3_max)
c
      anull=0.0
c
      fgrd1='grd1.grd'
      fgrd2='grd2.grd'
c
      call getarg(1,arg) 
      if(arg(1:2).eq.'-h') then
      write(6,499)
 499  format('usage: 2potsim_noskin -g1 grd1.grd -g2 grd2.grd')
      call exit
      end if
      nargs=iargc()
      do ia=1,nargs-1
      call getarg(ia,arg)
      if(arg(1:3).eq.'-g1') then
      call getarg(ia+1,fgrd1)
      end if
      if(arg(1:3).eq.'-g2') then
      call getarg(ia+1,fgrd2)
      end if
      end do
c
      ilog=13
      iform=0
c. Above are the hardcoded conventions
      iugrd1=11
      iugrd2=12
c
c begin code
c
c read the 3D grid
c
	  write(ilog,*)
	  write(ilog,*) 'Grid # 1 file reading now... wait...'
      call inpgrd(fgrd1,iugrd2,iform,im,jm,km,
     &             h,xo,yo,zo,grd1)
	  write(ilog,611) im,jm,km,h,xo,yo,zo
	  write(ilog,*)
	  write(ilog,*) 'Grid # 2 file reading now... wait...'
      call inpgrd(fgrd2,iugrd2,iform,im,jm,km,
     &             h,xo,yo,zo,grd2)
	  write(ilog,611) im,jm,km,h,xo,yo,zo
c
 611  format('grid dimensions:  ',i3,2('.',i3),'  spacing:',f8.3,/,
     ,'grid origin:',3f8.3)
      imjmkm=im*jm*km
	  call over(grd1,grd1,an11,imjmkm)
	  call over(grd2,grd2,an22,imjmkm)
	  call over(grd1,grd2,an12,imjmkm)

	  write(6,612) 2.*an12/(an11+an22),an12/sqrt(an11*an22),
     ,an11,an22,an12,anull,anull
c 612  format(2f8.4,3e12.4)
 612  format(2f7.3,5e15.7,2f7.3,3i7)

 1000  continue
      stop
c
      end
      subroutine over(grida,gridb,ov,npoi)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      dimension grida(npoi)
      dimension gridb(npoi)
c
      integer i,npoi
	  real*8 ovd
c
c begin code
c
c calculate the overlapping      
c
	  ovd=0.0d0
      do 130 i=1,npoi     
	  ovd=ovd+grida(i)*gridb(i)
  130 continue
      ov=ovd
      return
      end
      subroutine inpgrd( filnam,iounit,iform,im,jm,km,
     &                   h,ox,oy,oz,grid) 
      include "maxdim.inc"
c
c. This is essentially a copy from UHBD version 4.1
      character*250 filnam
      integer iounit, iform
      character*72 title
      integer im, jm, km
	  dimension grid(1)
      integer grdflg
      integer stderr
c
      real dum2, dum3, dum4, dum5, dum6, dum7, dum8
      integer idum1, idum2, idum3, idum4, idum5, idum6, idum7
      integer i, j, k, l, kx
      real xbuf(im_max*im_max*2)
	  stderr=6
c
      if ( iform .eq. 0 ) then
         open(iounit, file=filnam, form='unformatted', status='old' )
         read(iounit) title, scale, dum2, idum1, idum2,
     &                idum3, idum4, idum5, im, jm, km,
     &                h, ox, oy, oz,
     &                dum3, dum4, dum5, dum6, dum7, dum8, idum6, idum7
         if ( im*jm .gt. im_max*im_max*2 ) then
            write(stderr,99001)
            stop
c???
c???
         endif
         if ( im*jm*km .gt. im3_max ) then
            write(stderr,99002)
            stop
         endif
         do  10  k = 1 , km
            read(iounit) kx, im, jm
            read(iounit) (xbuf(l), l = 1 , im*jm)
            do  9  l = 1 , im*jm
c              grid((k-1)*im*jm+l) = xbuf(l) / scale
               grid((k-1)*im*jm+l) = xbuf(l)        
    9       continue
   10    continue
         close(iounit)
      else if ( iform .eq. 1 ) then
         open( iounit, file=filnam, form='formatted', status='old' )
         read(iounit,77) title, scale, dum2, idum1, idum2,
     &                   idum3, idum4, idum5, im, jm, km,
     &                   h, ox, oy, oz,
     &                   dum3, dum4, dum5, dum6, dum7, dum8,
     &                   idum6, idum7
         if ( im*jm*km .gt. im3_max ) then
            write(stderr,99002)
            stop
         endif
         do  20  k = 1 , km
            read(iounit,78) kx, im, jm
            read(iounit,79) ( grid((k-1)*im*jm+l), l=1,im*jm )
   20    continue
         close(iounit)
      endif
      return
c
c..........
c
c               Format statements.
c
   77 format(a72/2e12.6,5i7/3i7,4e12.6/4e12.6/2e12.6,2i7)
   78 format(3i7)
   79 format( (6(1x,e12.6)) )
99001 format(1x,'FATAL: inpgrd(001) buffer too small.' )
99002 format(1x,'FATAL: inpgrd(002) grid too large. ',
     .          'recompile with larger im_max value.' )
      end

c----------------------------------------------------------------------
c  program n1potsim    
c  PIPSA version 3.0 (Jan 2007)          
c
c  Authors: R.R.Gabdoulline, R.C.Wade
c  Copyright (c) 2004
c  EML Research gGmbH, Schloss-Wolfsbrunnenweg 33, 69118 Heidelberg,
c  Germany, and
c  European Molecular Biology Laboratory, Heidelberg, Germany
c
c  This copyright notice must be attached to all copies, or extracts,
c  of this software.
c
c  Please obtain a license before using this software from the PIPSA
c  website or "rebecca.wade@eml-r.villa-bosch.de".
c  Conditions of usage are as specified in the license agreement.
c
c  Queries about problems with this software should be addressed to
c  "razif.gabdoulline@eml-r.villa-bosch.de".
c
c  References:
c  N. Blomberg, R.R. Gabdoulline, M. Nilges and R. C. Wade.
c   Classification of protein sequences by homology modeling and
c   quantitative analysis of electrostatic similarity.
c   Proteins: Str., Function and Genetics, 37:379-387 (1999)
c  Wade,R.C., Gabdoulline, R.R. and De Rienzo, F.
c   Protein Interaction Property Similarity Analysis
c   Intl. J. Quant. Chem., 83:122-127 (2001).
c----------------------------------------------------------------------
c
c drives similarity index calculations with 2potsim* when 1 extra protein 
c to be added to the set of originally processed proteins
c
c Input:
c - command line arg -pg - similarity calculation program name
c   2potsim_noskin, 2potsim_skin or 2potsim_skin_parts, 
c   default is ../bin/2potsim_noskin
c - command line arg -fp - the directory where pdb files are located, 
c   default is ../pdbs
c - command line arg -fn - the name of the file with the names of 
c   original set of proteins, each of which should have corresponding 
c   PDB file in the directory ../pdbs/, and corresponding potential file in ./
c   default is "names"
c - command line arg -p1 - the name of the protein to be added, 
c   should have PDB file in ../pdbs/, and the potential file in ./
c - command line arg -lg - the name of the similarity matrix file
c   default is "sims.log"
c - command line arg -pr - the value of probe radius
c   default is 3 A
c - command line arg -sk - the value of skin thickness
c   default is 4 A
c - command line arg -pa - the name of the file with the list of directions
c   default name "parts" - a list of directions and angles to define conical parts
c
c Note that 
c + the program implies that it is executed in the directory, where 
c   grid files are located and expects pdb files to be located in ../pdbs/ subdirectory
c + all grid files corresponding to protein names in the file "names" must have 
c   extension .grd and all pdb files must have extension .pdb
c + the file "names" after execution of this program will be renamed to "names-old" 
c   and a new file "names" will be created, which includes newly added protein name
c + the old similarity matrix file will be renamed to "sims.log-old" and new file 
c    "sims.log" (or any other name given after -lg) sill be created which has indices for added protein
c 
c
      include "maxdim.inc"
      character*256 pname,fname,lname,fparts,fpdbs,arg
      character*512 command,dum
      character*256 fnameo,lnameo,nap1
      character*256 ns(nprmx)
      character*1 s
c
      do i=1,512
      dum(i:i)=' '
      end do
c
      pname='../bin/2potsim_noskin'
      fpdbs='../pdbs'
      fname='names'
      lname='sims.log'
      probes=3.0
      skin=4.0
      fparts='parts'
      nap1='      '
      nargs=iargc()
c
      call getarg(1,arg) 
      if(arg(1:2).eq.'-h') then
      write(6,499)
 499  format('usage: n1potsim -pr program -fn fname -lg lname ',
     ,'-pr probe -sk skin -pa parts -p1 protein_name')
      call exit
      end if
      do ia=1,nargs-1
      call getarg(ia,arg)
      if(arg(1:3).eq.'-pg') then
      call getarg(ia+1,pname)
      end if
      if(arg(1:3).eq.'-fp') then
      call getarg(ia+1,fpdbs)
      end if
      if(arg(1:3).eq.'-fn') then
      call getarg(ia+1,fname)
      end if
      if(arg(1:3).eq.'-lg') then
      call getarg(ia+1,lname)
      end if
      if(arg(1:3).eq.'-pr') then
      call getarg(ia+1,arg)
      read(arg,*) probes
      end if
      if(arg(1:3).eq.'-sk') then
      call getarg(ia+1,arg)
      read(arg,*) skin
      end if
      if(arg(1:3).eq.'-pa') then
      call getarg(ia+1,fparts)
      end if
      if(arg(1:3).eq.'-p1') then
      call getarg(ia+1,nap1)
      end if
      end do
c
      open(11,file=fname)
      np=0
 1    continue
      read(11,'(a)',end=91) arg
      if(arg(1:6).eq.'      ') goto 1
      np=np+1
      ns(np)=arg
      goto 1
 91   continue
      close(11)
c
      open(12,file=lname)
      read(12,'(1x,i6)') npo
      close(12)
      if(npo.ne.np) then
      write(6,*) 'file with names says there were',np,'  proteins'
      write(6,*) 'file with sim matrix says there were',npo,'  proteins'
      write(6,*) 'please resolve the inconsistency first'
      call exit
      end if
      if(nap1.eq.'      ') then
      write(6,*) 'the name of the protein to add to the existing set',
     ,' must be given'
      write(6,499)
      call exit
      end if
c
      call slen(fname,lfn)
      write(fnameo,701) fname(1:lfn)
      command=dum
      write(command,702)  fname(1:lfn), fname(1:lfn)
      call slen512(command,lc)
      write(6,'(a)') command(1:lc)
      call system(command)
      call slen(lname,lln)
      write(lnameo,701) lname(1:lln)
      write(command,702)  lname(1:lln), lname(1:lln)
      call slen512(command,lc)
      write(6,'(a)') command(1:lc)
      call system(command)
 701  format(a,'-old')
 702  format('mv -f ',a,' ',a,'-old')
c
      open(13,file=lname)
      write(13,'(1H#,i6)') np+1
c
      open(12,file=lnameo)
      read(12,'(a)',end=95) arg
 112  continue
      read(12,'(a)',end=95) arg
      call slen(arg,la)
      write(13,'(a)') arg(1:la)
      goto 112
 95   continue
      close(12)
      close(13)
c
      open(11,file=fname)
      do j=1,np
c
      call slen(nap1,lp1)
      call slen(ns(j),lj)
      open(13,file=lname)
 131  continue
      read(13,'(a)',end=132) s
      goto 131
 132  continue
      write(13,'(a,1x,a)') nap1(1:lp1),ns(j)(1:lj)
      close(13)
c
      command=dum
      call slen(pname,lpg)
      call slen(fpdbs,lpdbs)
      call slen(lname,llg)
      call slen(fparts,lpa)
      write(command, 500) pname(1:lpg),nap1(1:lp1),ns(j)(1:lj),
     ,fpdbs(1:lpdbs),nap1(1:lp1),fpdbs(1:lpdbs),ns(j)(1:lj),
     ,fparts(1:lpa),probes,skin,lname(1:llg)
      call system(command)
      call slen512(command,lc)
      write(6,'(a)') command(1:lc)
c
      write(11,'(a)') ns(j)(1:lj)
      end do
      open(13,file=lname)
 133  continue
      read(13,'(a)',end=134) s
      goto 133
 134  continue
      write(13,'(a,1x,a)') nap1(1:lp1),nap1(1:lp1)
      close(13)
      write(13,'(a,1x,a)') nap1(1:lp1),nap1(1:lp1)
      write(command, 500) pname(1:lpg),nap1(1:lp1),nap1(1:lp1),
     ,fpdbs(1:lpdbs),nap1(1:lp1),fpdbs(1:lpdbs),nap1(1:lp1),
     ,fparts(1:lpa),probes,skin,lname(1:llg)
      call system(command)
      call slen512(command,lc)
      write(6,'(a)') command(1:lc)
c
      write(11,'(a)') nap1(1:lp1)
      close(11)
      close(13)
c
 500  format(a,' -g1 ',a,'.grd -g2 ',a,'.grd -p1 ',a,'/',a,
     ,'.pdb -p2 ',a,'/',a,'.pdb -pa ',a,' -pr ',f7.3,
     ,' -sk ',f7.3,' >> ',a)

c
      call exit
      end  
c
      subroutine slen(arg,na)
      character*256 arg
      na=1
      do ia=2,249
      na=ia-1
      if(arg(ia:ia+7).eq.'        ') return
      end do 
      return
      end

      subroutine slen512(arg,na)
      character*512 arg
      do i=512,1,-1
      na=i
      if(arg(i:i).ne.' ') return
      end do
      return
      end

c program delphi2uhbd
c
c Converts Delphi binary output grid to uhbd ascii format grid, 
c which can be then converted to binary uhbd by uhbd_asc2bin program 
c and used for PIPSA similarity analysis (or other purposes).
c
c The flag IBIOS while writing Delphi grid must be false  
c (i.e. grasp style phi-map is assumed).
c
c When compiled under linux, care must be taken depending on 
c under which platform the Dephi grids are computed and written.
c If SGI Irix version of Delphi was used, then the compilation 
c option -byteswapio must be used in order to grid be read correctly
c This option is not supported by g77, so one have to use, for example, 
c pgi or intel compilers. Executable compiled with pgi is supplied here.
c
c Should be no such problems, when both Delphi and delphi2uhbd are 
c the same platform executables.
c
c R. Gabdoulline, gabdoulline@eml.org, December 2004
c
      character*80 delphifile,uhbdfile
c
      character*20 uplbl
c      character*10 nxtlbl,character*60 toplbl
      character*10 nxtlbl
      character*60 toplbl
      real phi(65,65,65)
      character*16 botlbl
      real scale,oldmid(3)
c
      integer im, jm, km, grdflg, one, kk
      character*72 title
      real h, ox, oy, oz, uscale
      real dum2, dum3, dum4, dum5, dum6, dum7, dum8
      integer idum2, idum3, idum4
      data dum2,dum3,dum4,dum5,dum6,dum7,dum8
     ,    / 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0/
      data idum2,idum3,idum4/0,0,0/
c
      if(iargc().lt.2) then
      write(6,601)
 601  format('Usage: delphi2uhbd delphi_grid_name uhbd_grid_name')
      call exit
      end if
c
      call getarg(1,delphifile)
      call getarg(2,uhbdfile)
      open (unit=11,file=delphifile,form='unformatted')
      write(6,602) delphifile,uhbdfile
 602  format('Converting delphi binary grid to uhbd ascii:',/,a,/,a)
c
      read (11) uplbl
      write(6,'(a)') uplbl
      read (11) nxtlbl,toplbl
      write(6,'(a)') nxtlbl
      write(6,'(a)') toplbl
      read (11) phi
      read (11) botlbl
      write(6,'(a)') botlbl
      read (11) dscale,oldmid
      write(6,*) dscale,oldmid
c
      close(11)
c
      write(title,'(a,2x,a)') nxtlbl,toplbl
      uscale=1.0
      grdflg=1
      one=1.0
      im=65
      jm=65
      km=65
      h=1.0/dscale
      ox=oldmid(1)-33.0*h
      oy=oldmid(2)-33.0*h
      oz=oldmid(3)-33.0*h
c
      open (unit=12,file=uhbdfile,status='new')
      write (12,77) title, uscale, dum2, grdflg, idum2,
     &               km, one, km, im, jm, km,
     &               h, ox, oy, oz,
     &               dum3, dum4, dum5, dum6, dum7,
     &               dum8, idum3, idum4
      do  20  k = 1 , km
      write(12,78) k,im,jm
      write(12,79) ((phi(i,j,k),i=1,im),j=1,jm)
   20 continue
c
      close(12)
c
   77 format(a72/2e12.6,5i7/3i7,4e12.6/4e12.6/2e12.6,2i7)
   78 format(3i7)
   79 format( (6(1x,e12.6)) )

      end

c----------------------------------------------------------------------
c  program modeller2grin
c  PIPSA version 3.0 (Jan 2007)          
c
c  Authors: R.R.Gabdoulline, R.C.Wade
c  Copyright (c) 2004
c  EML Research gGmbH, Schloss-Wolfsbrunnenweg 33, 69118 Heidelberg,
c  Germany, and
c  European Molecular Biology Laboratory, Heidelberg, Germany
c
c  This copyright notice must be attached to all copies, or extracts,
c  of this software.
c
c  Please obtain a license before using this software from the PIPSA
c  website or "rebecca.wade@eml-r.villa-bosch.de".
c  Conditions of usage are as specified in the license agreement.
c
c  Queries about problems with this software should be addressed to
c  "razif.gabdoulline@eml-r.villa-bosch.de".
c
c  References:
c  N. Blomberg, R.R. Gabdoulline, M. Nilges and R. C. Wade.
c   Classification of protein sequences by homology modeling and
c   quantitative analysis of electrostatic similarity.
c   Proteins: Str., Function and Genetics, 37:379-387 (1999)
c  Wade,R.C., Gabdoulline, R.R. and De Rienzo, F.
c   Protein Interaction Property Similarity Analysis
c   Intl. J. Quant. Chem., 83:122-127 (2001).
c----------------------------------------------------------------------
c
c. reads output from MODELLER and changes the names of atoms 
c. to the names recognizable by GRIN routine of GRID
c
cATOM      2  CA  ASN     1      16.035  -8.224   5.143  1.00  3.50       1SG   3
c12345678901234567890123456789012345678901234567890123456789012345678901234567890
c         1         2         3         4         5         6         7
c(a4,2x,i5,1x,a4,1x,a4,1x,i4,4x,3f8.3,2f6.2)
c atom name: (14:16)
c
      parameter(nchmax=99)
      character*80 s
      character*3 na_old(nchmax) 
      character*3 na_new(nchmax) 
c
c. edit these if more needed
      nch=2
      na_old(1)='OT1'
      na_new(1)='O  '
      na_old(2)='OT2'
      na_new(2)='OXT'
c
 1    continue
      read(5,'(a)',end=91) s
      if(s(1:4).eq.'ATOM') then
        do i=1,nch
        if(s(14:16).eq.na_old(i)) s(14:16)=na_new(i)
        end do 
      end if
      write(6,'(a)') s
      goto 1
 91   continue
      call exit
      end

c----------------------------------------------------------------------
c  program qdipsim     
c  PIPSA version 3.0 (Jan 2007)          
c
c  Authors: R.R.Gabdoulline, R.C.Wade
c  Copyright (c) 2004
c  EML Research gGmbH, Schloss-Wolfsbrunnenweg 33, 69118 Heidelberg,
c  Germany, and
c  European Molecular Biology Laboratory, Heidelberg, Germany
c
c  This copyright notice must be attached to all copies, or extracts,
c  of this software.
c
c  Please obtain a license before using this software from the PIPSA
c  website or "rebecca.wade@eml-r.villa-bosch.de".
c  Conditions of usage are as specified in the license agreement.
c
c  Queries about problems with this software should be addressed to
c  "razif.gabdoulline@eml-r.villa-bosch.de".
c
c  References:
c  N. Blomberg, R.R. Gabdoulline, M. Nilges and R. C. Wade.
c   Classification of protein sequences by homology modeling and
c   quantitative analysis of electrostatic similarity.
c   Proteins: Str., Function and Genetics, 37:379-387 (1999)
c  Wade,R.C., Gabdoulline, R.R. and De Rienzo, F.
c   Protein Interaction Property Similarity Analysis
c   Intl. J. Quant. Chem., 83:122-127 (2001).
c----------------------------------------------------------------------
c
CccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccC
c
c Computes pairwise electrostatic similarity of a list of proteins, 
c based on their monopole and dipole moments 
c
c Input: 
c - command line arg -fn - the name of the file with the names of proteins, 
c   each of which should have corresponding PDB file in the current directory
c   default is "pdbnames"
c - command line arg -fd - the name of the file where dipole moment 
c   information will be written
c   default name "dipoles" 
c - command line arg -r - the size of the proteins, approx average gyration radius
c   default value 9.815 A, valid for PH domains
c
c The program will assign formal charges to all charged residues 
c (+0.5 for NHX of Arg, +1 for NZ of Lys, -0.5 for OEX of Glu and ODX of Asp, 
c compute the monopole and dipole moments of protein.  
c The similarity index is computed then following the analytical formula 
c (6) from the Proteins paper, i.e. comparing monopole+dipole potentials 
c at the sphere of some radius R. Hardcoded value of R is 9.815, i.e. 
c parameter alpha (coded as scf) is 17 A**-2.   
c
c The following quantities are computed:
c aa   = square of the norm of the dipole+monopole potential of protein 1
c bb   = square of the norm of the dipole+monopole potential of protein 2
c ab   = scalar product of 2 dipole+monopole potentials
c
c  Output:
c - file "dipoles" where the following information about proteins are printed:
c   the name of pdb-file
c   total charge
c   norm of the dipole moment
c   3 (x,y,z) components of the dipole moment 
c   number of charge sites    
c - fort.6 - standard output has following data in one line:
c
c   si_hodgkin = 2*ab/(aa+bb)
c   si_carbo   = ab/sqrt(aa*bb)
c   aa
c   bb
c   ab
c   aa
c   bb
c   npoi
c
CccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccC
      include "maxdim.inc"
      dimension d(3,nprmx),c(3,nprmx),q(nprmx),cc(3),cv(3)
      dimension d1(3),d2(3)
      integer nq(nprmx),lfn(nprmx)
      character*256 fname(nprmx),fnamet,ffname,fdipoles,arg
c
      ffname='pdbnames'
      fdipoles='dipoles'
      rprot=9.815
      nargs=iargc()
      call getarg(1,arg) 
      if(arg(1:2).eq.'-h') then
      write(6,499)
 499  format('usage: qdipsim -fn pdbnames -fd dipoles -r rprot')
      call exit
      end if
      do ia=1,nargs-1
      call getarg(ia,arg)
      if(arg(1:3).eq.'-fn') then
      call getarg(ia+1,ffname)
      end if
      if(arg(1:3).eq.'-fd') then
      call getarg(ia+1,fdipoles)
      end if
      if(arg(1:2).eq.'-r') then
      call getarg(ia+1,arg)
      read(arg,*) rprot
      end if
      end do
c
      open(12,file=ffname)
      np=0
 12   continue
      read(12,'(a)',end=92) fnamet
      if(fnamet(1:6).eq.'      ') goto 92
      call pdbfl(fnamet,lfnt)
      np=np+1
      call dipole1(fnamet,cv,q1,d1,nq1)
      nq(np)=nq1
      q(np)=q1
        do m=1,3
      d(m,np)=d1(m)
      c(m,np)=cv(m)
        end do
      fname(np)=fnamet
      lfn(np)=lfnt
      goto 12
 92   continue
      close(12)
      write(6,'(1H#,i6)') np
c
       do m=1,3
      cc(m)=0.0
      do i=1,np
      cc(m)=cc(m)+c(m,i)
      end do
      cc(m)=cc(m)/float(np)
       end do
      open(11,file='center')
      write(11,*) cc
      close(11)
c
      open(13,file=fdipoles)
      do i=1,np
       do m=1,3
       d(m,i)=d(m,i)-cc(m)*q(i)
       end do
       dlen=sqrt(d(1,i)**2+d(2,i)**2+d(3,i)**2)
      lfnt=lfn(i)
      write(13,'(a)') fname(i)(1:lfnt)
      write(13,502) q(i),dlen,(d(k,i),k=1,3),nq(i)
      end do
      close(13)
c
      scf=rprot**(-2)/3.0
c
      do i=1,np
      do j=1,i
      li=lfn(i)
      lj=lfn(j)
      write(6,'(a,x,a)') fname(i)(1:li),fname(j)(1:lj)
      d1(1)=d(1,i)
      d1(2)=d(2,i)
      d1(3)=d(3,i)
      d2(1)=d(1,j)
      d2(2)=d(2,j)
      d2(3)=d(3,j)
      call abc(q(i),d1,q(j),d2,scf,aa,bb,ab)
       write(6,612) 2*ab/(aa+bb),ab/sqrt(aa*bb),aa,bb,ab,aa,bb
c     ,,2.*float(npoi)/float(np1+np2),float(npoi)/sqrt(float(np1*np2)),
c     ,np1,np2,npoi
      end do
      end do
 612  format(2f7.3,5e15.7,2f7.3,3i7)
 502  format(f10.3,3x,f10.3,3x,3f10.3,i6)
c
      call exit
      end
      subroutine dipole1(fname,c,chnet,d,ncha)
      dimension xv(3),d(3),c(3)
c. c here - computed !!
      character*54 string
      character*40 fname 
	  character*4 atom
      character*3 aname,rname
      character*1 space 
      logical uncharged
	  data atom/'ATOM'/,space/' '/
c
        do m=1,3
      d(m)=0.
      c(m)=0.
        end do
      chnet=0.0
      achnet=0.0
      ncha=0
      na=0
      open(1,file=fname)
  1   continue
	  read(1,500,end=99) string
	  if(string(1:4).ne.atom) goto 1
	  read(string(31:54),501) xv
         na=na+1
         do m=1,3
         c(m)=c(m)+xv(m)
         end do
       aname=string(14:16)
       if(string(14:14).eq.space) then
       aname=string(15:17)
       if(string(15:15).eq.space) then
       aname=string(16:18)
       aname(3:3)=space
       end if
       end if
       rname=string(18:20)
      call chdef(aname,rname,uncharged,cha) 
      if(uncharged) goto 1
c      cha=cha*78.
c      write(6,'(2a3,f8.3)') aname,rname,cha
	  chnet=chnet+cha
	  achnet=achnet+abs(cha)
      d(1)=d(1)+xv(1)*cha
      d(2)=d(2)+xv(2)*cha
      d(3)=d(3)+xv(3)*cha
      ncha=ncha+1
	  goto 1
c
  99  continue
      close(1)
         do m=1,3
         c(m)=c(m)/float(na)
         end do
 500  format(a)
 501  format(3f8.3)
 502  format(f10.3,3x,f10.3,3x,3f10.3,i6)
c
	  return   
      end
	   subroutine chdef(aname,rname,uncharged,charge)
	   character*3 aname,rname
	   logical uncharged
       charge=0.00
	   uncharged=.true.
c
	   if(aname.eq.'N'.and.rname.eq.'NTR') uncharged=.false.
	   if(aname.eq.'N'.and.rname.eq.'NTR') charge=1.00  
	   if(aname.eq.'NZ'.and.rname.eq.'LYS') uncharged=.false.
	   if(aname.eq.'NZ'.and.rname.eq.'LYS') charge=1.00  
	   if(aname.eq.'NH1'.and.rname.eq.'ARG') uncharged=.false.
	   if(aname.eq.'NH1'.and.rname.eq.'ARG') charge=0.50  
	   if(aname.eq.'NH2'.and.rname.eq.'ARG') uncharged=.false.
	   if(aname.eq.'NH2'.and.rname.eq.'ARG') charge=0.50  
	   if(aname.eq.'OD1'.and.rname.eq.'ASP') uncharged=.false.
	   if(aname.eq.'OD1'.and.rname.eq.'ASP') charge=-0.50  
	   if(aname.eq.'OD2'.and.rname.eq.'ASP') uncharged=.false.
	   if(aname.eq.'OD2'.and.rname.eq.'ASP') charge=-0.50  
	   if(aname.eq.'OE1'.and.rname.eq.'GLU') uncharged=.false.
	   if(aname.eq.'OE1'.and.rname.eq.'GLU') charge=-0.50  
	   if(aname.eq.'OE2'.and.rname.eq.'GLU') uncharged=.false.
	   if(aname.eq.'OE2'.and.rname.eq.'GLU') charge=-0.50  
	   if(aname.eq.'OT1'.and.rname.eq.'CTR') uncharged=.false.
	   if(aname.eq.'OT1'.and.rname.eq.'CTR') charge=-0.50  
	   if(aname.eq.'OT2'.and.rname.eq.'CTR') uncharged=.false.
	   if(aname.eq.'OT2'.and.rname.eq.'CTR') charge=-0.50  
	   if(aname.eq.'O1'.and.rname.eq.'CTR') uncharged=.false.
	   if(aname.eq.'O1'.and.rname.eq.'CTR') charge=-0.50  
	   if(aname.eq.'O2'.and.rname.eq.'CTR') uncharged=.false.
	   if(aname.eq.'O2'.and.rname.eq.'CTR') charge=-0.50  
	   if(aname.eq.'O'.and.rname.eq.'CTR') uncharged=.false.
	   if(aname.eq.'O'.and.rname.eq.'CTR') charge=-0.50  
	   if(aname.eq.'OXT'.and.rname.eq.'CTR') uncharged=.false.
	   if(aname.eq.'OXT'.and.rname.eq.'CTR') charge=-0.50  
c
	   return
	   end
       subroutine abc(q1,d1,q2,d2,scf,aa,bb,ab)
       dimension d1(3),d2(3)
       aa=q1*q1+scf*(d1(1)*d1(1)+d1(2)*d1(2)+d1(3)*d1(3))
       bb=q2*q2+scf*(d2(1)*d2(1)+d2(2)*d2(2)+d2(3)*d2(3))
       ab=q1*q2+scf*(d1(1)*d2(1)+d1(2)*d2(2)+d1(3)*d2(3))
       return
       end
       subroutine pdbfl(name,l)
       character*256 name
       character*4 pdbe,sp4
       data pdbe/'.pdb'/,sp4/'    '/
c
       do 10 i=1,253
       l=i
       i3=i+3
       if(name(i:i3).eq.pdbe) goto 9
       if(name(i:i3).eq.sp4) goto 9
 10    continue
  9    continue
       l=l-1
       return
       end

c----------------------------------------------------------------------
c  program uhbd_asc2bin 
c  PIPSA version 3.0 (Jan 2007)          
c
c  Authors: R.R.Gabdoulline, R.C.Wade
c  Copyright (c) 2004
c  EML Research gGmbH, Schloss-Wolfsbrunnenweg 33, 69118 Heidelberg,
c  Germany, and
c  European Molecular Biology Laboratory, Heidelberg, Germany
c
c  This copyright notice must be attached to all copies, or extracts,
c  of this software.
c
c  Please obtain a license before using this software from the PIPSA
c  website or "rebecca.wade@eml-r.villa-bosch.de".
c  Conditions of usage are as specified in the license agreement.
c
c  Queries about problems with this software should be addressed to
c  "razif.gabdoulline@eml-r.villa-bosch.de".
c
c  References:
c  N. Blomberg, R.R. Gabdoulline, M. Nilges and R. C. Wade.
c   Classification of protein sequences by homology modeling and
c   quantitative analysis of electrostatic similarity.
c   Proteins: Str., Function and Genetics, 37:379-387 (1999)
c  Wade,R.C., Gabdoulline, R.R. and De Rienzo, F.
c   Protein Interaction Property Similarity Analysis
c   Intl. J. Quant. Chem., 83:122-127 (2001).
c----------------------------------------------------------------------
c
c By Dave Sept, modified from UHBD utility
c Modified for pipsa 2.0 April 2004
c 
c Converts grid from UHBD ASCII format to UHBD binary format
c
c     iunit        i     unit number to use for writing.
c     iform        i     0=unformatted file, 1=formatted file.
c     title        i     title for file.
c     im           i     numbers of points in x - direction.
c     jm           i     numbers of points in y - direction.
c     km           i     numbers of points in z - direction.
c     h            i     distance between grid points.
c     ox \             / coordinate of grid point (0,0,0)
c     oy  >        i  <  such that the coordinates of (i,j,k) are
c     oz /             \ ( ox+h*i, oy+h*j, oz+h*k).
c     grdflg       i     flag indicating the type of grid.
c     grid         i     grid of values to be printed out.
c     scale        i     factor multiplied times the grid that is output.
c
      include "maxdim.inc"
      integer im, jm, km, grdflg, one, kk
      integer iunit, iform
      character*72 title
      real h, ox, oy, oz, grid(im_max,im_max,im_max), scale
      real x0, y0, z0, x1, y1, z1, xmax, ymax, zmax, 
     &     xstart, ystart, zstart, xend, yend, zend
  
c     dum#         dummy real variables
c     idum#        dummy integer variables
c
      real dum2, dum3, dum4, dum5, dum6, dum7, dum8
      integer idum2, idum3, idum4
c
      integer i, j, k, ounit
c
c     flnm          name of trajectory file.
c     newfle        output DCD file name (stemunit.sub.DCD)
c     stem          output DCD file name stem
c     string
c
c      character*20 newfle
c      character*80 flnm
      character*4 stem
      character*1 string
      character*256 flnm,newfle
c
c Statement functions
c begin code
c
      if(iargc().lt.2) then
      write(6,601)
 601  format('Usage: uhbd_asc2bin asci_grid_name bin_grid_name')
      call exit
      end if
c
      call getarg(1,flnm)
      call getarg(2,newfle)
c
c      write(6,100) 
c100   format(1x,'Convert UHBD ascii grid to binary')
c
c      write(6,130) 
c130   format(1x,'Enter grid map file name:')
c      read(5,135) flnm
c135   format(a)
c      write(6,140) flnm
c140   format(1x,'Grid input file :',a)
      iunit=11
      open(unit=11, file = flnm, status = 'old')
c
c      write(6,145) 
c145   format(1x,'Enter output file name:')
c      read(5,135) newfle
c      write(6,148) newfle
c148   format(1x,'Grid output file :',a)
c
       ounit=12
         open(12, file = newfle, status='new', form='unformatted')
c            call uhopen(12, newfle, 0)
c
c
        read (iunit,77) title, scale, dum2, grdflg, idum2,
     &                    km, one, km, im, jm, km,
     &                         h ,      ox ,      oy ,      oz ,
     &                    dum3, dum4, dum5, dum6, dum7,
     &                    dum8, idum3, idum4

        write (ounit) title, scale, dum2, grdflg, idum2,
     &                    km, one, km, im, jm, km,
     &                         h ,      ox ,      oy ,      oz ,
     &                    dum3, dum4, dum5, dum6, dum7,
     &                    dum8, idum3, idum4
c
        do  20  k = 1 , km
          read(iunit,78) kk, im, jm
          read(iunit,79) ( ( grid(i,j,k), i=1,im), j=1,jm )
   20   continue
c
      do  30  k = 1 , km
          write(ounit) k, im, jm
          write(ounit) ( ( grid(i,j,k), i=1,im), j=1,jm )
   30 continue
c
      close(iunit)
      close(ounit)
c
c
c               Format statements.
c
   77 format(a72/2e12.6,5i7/3i7,4e12.6/4e12.6/2e12.6,2i7)
   78 format(3i7)
   79 format( (6(1x,e12.6)) )
      end

c----------------------------------------------------------------------
c  program grid_asc2bin
c  PIPSA version 3.0 (Jan 2007)          
c
c  Authors: R.R.Gabdoulline, R.C.Wade
c  Copyright (c) 2004
c  EML Research gGmbH, Schloss-Wolfsbrunnenweg 33, 69118 Heidelberg,
c  Germany, and
c  European Molecular Biology Laboratory, Heidelberg, Germany
c
c  This copyright notice must be attached to all copies, or extracts,
c  of this software.
c
c  Please obtain a license before using this software from the PIPSA
c  website or "rebecca.wade@eml-r.villa-bosch.de".
c  Conditions of usage are as specified in the license agreement.
c
c  Queries about problems with this software should be addressed to
c  "razif.gabdoulline@eml-r.villa-bosch.de".
c
c  References:
c  N. Blomberg, R.R. Gabdoulline, M. Nilges and R. C. Wade.
c   Classification of protein sequences by homology modeling and
c   quantitative analysis of electrostatic similarity.
c   Proteins: Str., Function and Genetics, 37:379-387 (1999)
c  Wade,R.C., Gabdoulline, R.R. and De Rienzo, F.
c   Protein Interaction Property Similarity Analysis
c   Intl. J. Quant. Chem., 83:122-127 (2001).
c----------------------------------------------------------------------
c
c Converts grid from GRID ASCII format to UHBD binary format
c GRID binary GRIDKONT can be converted to this ASCII format by k2a program
c
      include "maxdim.inc"
      integer im, jm, km, grdflg, mxgrd, one, kk
      integer iunit, iform
      character*72 title
      real h, ox, oy, oz, grid(im_max,im_max,im_max), scale
      real x0, y0, z0, x1, y1, z1, xmax, ymax, zmax, 
     &     xstart, ystart, zstart, xend, yend, zend
      real dum2, dum3, dum4, dum5, dum6, dum7, dum8
      integer idum2, idum3, idum4
      integer i, j, k, ounit
      character*4 stem
      character*1 string
      character*256 flnm,newfle,s
c
c begin code
c
      if(iargc().lt.2) then
      write(6,601)
 601  format('Usage: grid_asc2bin asci_grid_name bin_grid_name')
      call exit
      end if
c
      call getarg(1,flnm)
      call getarg(2,newfle)
      open(11, file = flnm, status = 'old')
      open(12, file = newfle, status='new', form='unformatted')
c
c        read (11,77) title, scale, dum2, grdflg, idum2,
c     &                    km, one, km, im, jm, km,
c     &                         h ,      ox ,      oy ,      oz ,
c     &                    dum3, dum4, dum5, dum6, dum7,
c     &                    dum8, idum3, idum4
      scale=1.0
      dum2=0.0
      grdflg=-1
      idum2=0
      one=1
      dum3=0.0
      dum4=0.0
      dum5=0.0
      dum6=0.0
      dum7=0.0
      dum8=0.0
      idum3=0
      idum4=0
 111  continue
      read(11,'(a)',end=99) s
      if(s(1:8).ne.' HEADER ') goto 111
      read(11,'(a)',end=99) s
      read(11,'(a)',end=99) title
c
 112  continue
      read(11,'(a)',end=99) s
      if(s(1:10).ne.' GRID size') goto 112
      read(11,'(a)',end=99) s
      read(11,'(a)',end=99) s
c  NNX:  65             NNY:  65             NNZ:  65
      do i=1,256
      if(s(i:i+3).eq.'NNX:') read(s(i+4:i+8),*) im
      if(s(i:i+3).eq.'NNY:') read(s(i+4:i+8),*) jm
      if(s(i:i+3).eq.'NNZ:') read(s(i+4:i+8),*) km
      end do
 113  continue
      read(11,'(a)',end=99) s
      if(s(1:10).ne.' GRID spac') goto 113
      read(11,'(a)',end=99) s
      read(11,'(a)',end=99) s
c   RA:   1.000          RX: -11.651          RY: -19.853          RZ: -21.540
            do i=1,256
      if(s(i:i+2).eq.'RA:') read(s(i+3:i+11),*) h 
      if(s(i:i+2).eq.'RX:') read(s(i+3:i+11),*) ox
      if(s(i:i+2).eq.'RY:') read(s(i+3:i+11),*) oy
      if(s(i:i+2).eq.'RZ:') read(s(i+3:i+11),*) oz
      end do
 114  continue
      read(11,'(a)',end=99) s
      if(s(1:10).ne.' Results f') goto 114
c
        write (12) title, scale, dum2, grdflg, idum2,
     &                    km, one, km, im, jm, km,
     &                         h ,      ox ,      oy ,      oz ,
     &                    dum3, dum4, dum5, dum6, dum7,
     &                    dum8, idum3, idum4
c
c        do  20  k = 1 , km
c          read(11,78) kk, im, jm
c          read(11,79) ( ( grid(i,j,k), i=1,im), j=1,jm )
c   20   continue
c
      do k=1,km
c      write(6,*) k
      do i=1,im
      read(11,*)
      read(11,501) (grid(i,j,k),j=1,jm)
      end do
 115  continue
      read(11,'(a)',end=98) s
      if(s(1:10).ne.' Results f') goto 115
      end do
c
c   1    1.223  1.236  1.250  1.264  1.278  1.293  1.307  1.321  1.335  1.349
c12345678901234567890123456789012345678901234567890123456789012345678901234567890
 501  format(6x,10f7.3)
c
 98   continue
      do  30  k = 1 , km
          write(12) kk, im, jm
          write(12) ( ( grid(i,j,k), i=1,im), j=1,jm )
   30 continue
c
      close(11)   
      close(12)   
 99   continue
c
c
c               Format statements.
c
   77 format(a72/2e12.6,5i7/3i7,4e12.6/4e12.6/2e12.6,2i7)
   78 format(3i7)
   79 format( (6(1x,e12.6)) )
      end

c----------------------------------------------------------------------
c  program mkapbsin    
c  PIPSA version 3.0 (Jan 2007)          
c
c  Authors: R.R.Gabdoulline, R.C.Wade
c  Copyright (c) 2004
c  EML Research gGmbH, Schloss-Wolfsbrunnenweg 33, 69118 Heidelberg,
c  Germany, and
c  European Molecular Biology Laboratory, Heidelberg, Germany
c
c  This copyright notice must be attached to all copies, or extracts,
c  of this software.
c
c  Please obtain a license before using this software from the PIPSA
c  website or "rebecca.wade@eml-r.villa-bosch.de".
c  Conditions of usage are as specified in the license agreement.
c
c  Queries about problems with this software should be addressed to
c  "razif.gabdoulline@eml-r.villa-bosch.de".
c
c  References:
c  N. Blomberg, R.R. Gabdoulline, M. Nilges and R. C. Wade.
c   Classification of protein sequences by homology modeling and
c   quantitative analysis of electrostatic similarity.
c   Proteins: Str., Function and Genetics, 37:379-387 (1999)
c  Wade,R.C., Gabdoulline, R.R. and De Rienzo, F.
c   Protein Interaction Property Similarity Analysis
c   Intl. J. Quant. Chem., 83:122-127 (2001).
c----------------------------------------------------------------------
c
c This is for apbs version 0.3.2 and newer, taking into account 
c corrected uhbd grid origin writing
c
c Rewrites apbs input file changing center of grids 
c and ionic strength value
c
c Input:
c - command line arg -ft - location of template apbs input file
c   default "apbs.in_tmpl", this means that the template file is 
c   copied from pipsa directory to the current . 
c - command line arg -is - ionic strength in mM
c   default 50 mM
c - command line arg -fu - input file to be used for UHBD calculations
c   default "apbs.in"
c - standard input - output of ccenter.f - a table of centers of 
c   proteins in a set
c
c Output:
c   Information about the spread of centers and extents of proteins

      include "maxdim.inc"
      character*256 arg,s,fapbst,fapbsin,se
      character*1 key
      dimension x(nprmx),y(nprmx),z(nprmx),d(nprmx)
      data key/'#'/
c
      do ii=1,256
      se(ii:ii)=' '
      end do
c
      fapbst='apbs.in_tmpl'
      fapbsin='apbs.in'
      aios=50.0
c
      call getarg(1,arg) 
      if(arg(1:2).eq.'-h') then
      write(6,499)
 499  format('usage: mkapbsin -ft apbs.in_tmpl -fu apbs.in ',
     ,'-is ionic_str_in_mM < center.log')
      call exit
      end if
c
      nargs=iargc()
      do ia=1,nargs-1
      call getarg(ia,arg)
      if(arg(1:3).eq.'-ft') then
      call getarg(ia+1,fapbst)
      end if
      if(arg(1:3).eq.'-fu') then
      call getarg(ia+1,fapbsin)
      end if
      if(arg(1:3).eq.'-is') then
      call getarg(ia+1,arg)
      read(arg,*) aios
      end if
      end do
c
      xa=0.0
      ya=0.0
      za=0.0
      da=0.0
      ic=0
 1    continue
      read(5,'(a)',end=99) s
      if(s(1:1).ne.key) goto 1
      ic=ic+1 
      read(s(1:41),601) 
     r     x(ic),y(ic),z(ic),d(ic)
      xa=xa+x(ic)
      ya=ya+y(ic)
      za=za+z(ic)
      da=da+d(ic)
      goto 1
 99   continue
      nc=ic
      xa=xa/float(nc)
      ya=ya/float(nc)
      za=za/float(nc)
      da=da/float(nc)
c
      dx=0.0
      dd=0.0
      do ic=1,nc
      dx=dx+(xa-x(ic))**2+
     +(ya-y(ic))**2+(za-z(ic))**2
      dd=dd+(da-d(ic))**2
      end do
      dx=sqrt(dx/float(nc))
      dd=sqrt(dd/float(nc))
c
      open(81,file=fapbst)
c. get spacing from dime and glen to shift center 
 810  continue
      read(81,'(a)',end=820) s 
      if(s(1:4).eq.'dime') then
      read(s(5:256),*) napbsx,napbsy,napbsz
      end if
      if(s(1:4).eq.'glen') then
      read(s(5:256),*) eapbsx,eapbsy,eapbsz
      end if
      goto 810
 820  continue
c      spx=eapbsx/float(napbsx-1)
c      xa=xa-spx
c      spy=eapbsy/float(napbsy-1)
c      ya=ya-spy
c      spz=eapbsz/float(napbsz-1)
c      za=za-spz
      rewind(81)
c
      open(91,file=fapbsin)
 81   continue
      read(81,'(a)',end=82) s
      call slen(s,ns)
c
      if(s(1:3).eq.'ion') then
      read(s(4:ns),*) iq,aiosi,radi
      s=se
      write(s,'(3Hion,i3,2f6.3)') iq,aios/1000.,radi
      call slen(s,ns)
      end if 
      if(s(1:5).eq.'gcent') then
      s=se
      write(s,'(5Hgcent,3f8.3)') xa,ya,za
      call slen(s,ns)
      end if
c
      write(91,'(a)') s(1:ns)
      goto 81
 82   continue
      close(81)
      close(91)
c
      write(6,604) xa,ya,za,nc,dx,da
 604  format(/,'Ave center:',3f8.3,'  has been computed',/
     ,'rms of ',i3,' centers is',f8.3,'  compared to radii',f8.3)
c
 601  format(1x,3f8.3,8x,f8.3)
c
      call exit
      end
      subroutine slen(s,ns)
      character*256 s
      do i=256,1,-1
      ns=i
      if(s(i:i).ne.' ') return
      end do
      return
      end

c----------------------------------------------------------------------
c  program 2potsim_skin_parts
c  PIPSA version 3.0 (Jan 2007)          
c
c  Authors: R.R.Gabdoulline, R.C.Wade
c  Copyright (c) 2004
c  EML Research gGmbH, Schloss-Wolfsbrunnenweg 33, 69118 Heidelberg,
c  Germany, and
c  European Molecular Biology Laboratory, Heidelberg, Germany
c
c  This copyright notice must be attached to all copies, or extracts,
c  of this software.
c
c  Please obtain a license before using this software from the PIPSA
c  website or "rebecca.wade@eml-r.villa-bosch.de".
c  Conditions of usage are as specified in the license agreement.
c
c  Queries about problems with this software should be addressed to
c  "razif.gabdoulline@eml-r.villa-bosch.de".
c
c  References:
c  N. Blomberg, R.R. Gabdoulline, M. Nilges and R. C. Wade.
c   Classification of protein sequences by homology modeling and
c   quantitative analysis of electrostatic similarity.
c   Proteins: Str., Function and Genetics, 37:379-387 (1999)
c  Wade,R.C., Gabdoulline, R.R. and De Rienzo, F.
c   Protein Interaction Property Similarity Analysis
c   Intl. J. Quant. Chem., 83:122-127 (2001).
c----------------------------------------------------------------------
c
      include "maxdim.inc"
CccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccC
c
c Computes similarity of 2 potential grids on the molecular skin
c and over the cylindrical part of the space.
c
c Input:
c - command line arg -g1 - the name of the file with potential grid for protein 1 
c   in UHBD format, default grd1.grd
c - command line arg -g2 - the name of the file with potential grid for protein 2
c   in UHBD format, default grd2.grd
c - command line arg -p1 - the name of the file with atom coordinates of protein 1
c   in PDB format, default pdb1.pdb
c - command line arg -p2 - the name of the file with atom coordinates of protein 2
c   in PDB format, default pdb2.pdb
c  - command line arg -pa - the name of the file with the list of directions
c   default name "parts" - a list of (up to 99) directions and angles to define conical parts
c   format of the file "parts" is: xr1,xr2,radius, where xr1 and xr2
c   are 3 coordinates (in &Aring;) of the beginning and the end of the
c   vector defining the direction of the cylinder and radius defining the
c   extent of the cylinder.
c - command line arg -pr - probe radius, default is 3 A
c - command line arg -sk - skin thickness, default is 4 A
c + default values are used if no input given
c
c The program will construct 2 skins (for protein 1 and 2) having thickness
c "skin" and at distance "probes" from van der Waals surface of the proteins.
c (i.e. from "probes" to "probes+skin" distance), using the points of the
c potential grids.  The potential values outside this skin will never be used.
c The followings will be computed:
c np1  = no of points of the skin of the protein 1
c np2  = no of points of the skin of the protein 2
c npoi = no of points of the intersecion of 2 skins
c aa0  = square of the norm of the grid 1 on its skin
c aa   = square of the norm of the grid 1 on intersection of the skins
c bb0  = square of the norm of the grid 2 on its skin
c bb   = square of the norm of the grid 2 on intersection of the skins
c ab   = scalar product of 2 potentials (on intersection of skins)
c
c  Output:
c - fort.66 - some info about constructed skins
c - fort.6 - standard output has following data in one line:
c
c   si_hodgkin = 2*ab/(aa+bb)
c   si_carbo   = ab/sqrt(aa*bb)
c   aa
c   bb
c   ab
c   aa0
c   bb0
c   si_hodgkin_shape = 2.*float(npoi)/float(np1+np2)
c   si_carbo_shape   = float(npoi)/sqrt(float(np1*np2))
c   np1
c   np2
c   npoi
c + this info is printed for every part defined in the file "parts"
c
CccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccC
c
c 20.01.2003 - corrected wrong calculation of np2 and bb0
c
CccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccC
      character*256 fpdb1,fpdb2,fgrd1,fgrd2,arg,fparts,fpdbvol
      integer iform
      integer im, jm, km
      dimension xr1(3,99),xr2(3,99),ar(99),r1(3),r2(3)
      dimension grid1(im3_max)
      dimension grid2(im3_max)
      integer*1 isk1(im_max,im_max,im_max)
      integer*1 isk2(im_max,im_max,im_max)
      integer*1 isk1a(im_max,im_max,im_max)
      integer*1 isk2a(im_max,im_max,im_max)
	  character*54 str
      LOGICAL dopdbvol
      common/writePDB/dopdbvol,ipdbvol
      common/ius/iulog
	  common/probc/probes,skin
c
	  iupdb=8
	  iugrd=10
      iuparam=88
      iupart=77
      iulog=66
      ipdbvol=99
      dopdbvol=.FALSE.
c
c. hard coded here change if need
      fpdb1='pdb1.pdb'
      fpdb2='pdb2.pdb'
      fpdbvol='pdbvol.pdb'
      iform=0
      fgrd1='grd1.grd'
      fgrd2='grd2.grd'
      fparts='parts'
      probes=3.0
      skin=4.0
c
      call getarg(1,arg) 
      if(arg(1:2).eq.'-h') then
      write(6,499)
 499  format('usage: 2potsim_skin_parts -g1 grd1.grd -g2 grd2.grd ',
     ,'-p1 pdb1.pdb -p2 pdb2.pdb -pa parts -pr probe -sk skin -pv ',
     ,'pdbvol.pdb')
      call exit
      end if
c
      nargs=iargc()
      do ia=1,nargs-1
      call getarg(ia,arg)
      if(arg(1:3).eq.'-g1') then
      call getarg(ia+1,fgrd1)
      end if
      if(arg(1:3).eq.'-g2') then
      call getarg(ia+1,fgrd2)
      end if
      if(arg(1:3).eq.'-p1') then
      call getarg(ia+1,fpdb1)
      end if
      if(arg(1:3).eq.'-p2') then
      call getarg(ia+1,fpdb2)
      end if
      if(arg(1:3).eq.'-pv') then
      call getarg(ia+1,fpdbvol)
      dopdbvol=.true.
      end if
      if(arg(1:3).eq.'-pa') then
      call getarg(ia+1,fparts)
      end if
      if(arg(1:3).eq.'-pr') then
      call getarg(ia+1,arg)
      read(arg,*) probes
      end if
      if(arg(1:3).eq.'-sk') then
      call getarg(ia+1,arg)
      read(arg,*) skin
      end if
      end do
c
c begin code
c
      if (dopdbvol) then
       open(ipdbvol,FILE=fpdbvol,position='APPEND')
      end if
       pi=atan(1.0)*4.0
       a2r=pi/180.
       open(iupart,file=fparts)
       npart=0
 71    continue
       read(iupart,*,end=72) r1,r2,radius
       npart=npart+1
       ar(npart)=radius
       dn=sqrt((r1(1)-r2(1))**2+
     + (r1(2)-r2(2))**2+(r1(3)-r2(3))**2)
        do m=1,3
        xr1(m,npart)=r1(m)
        xr2(m,npart)=r2(m)
        end do
        goto 71
 72     continue
        close(iupart)
        write(iulog,*) 'will work on',npart,'  parts'
c
c read the 3D grid
c
	  write(iulog,*)
	  write(iulog,*) 'Grid 1 file reading now... wait...'
      call inpgrd(fgrd1,iugrd,iform,im,jm,km,
     &             h,xo,yo,zo,grid1)
	  write(iulog,611) im,jm,km,h,xo,yo,zo
c
      call  mkskin(ifpdb,fpdb1,im,jm,km,h,xo,yo,zo,np1,isk1)
c
	  write(iulog,*)
	  write(iulog,*) 'Grid 2 file reading now... wait...'
      call inpgrd(fgrd2,iugrd,iform,im,jm,km,
     &             h,xo,yo,zo,grid2)
	  write(iulog,611) im,jm,km,h,xo,yo,zo
c
      call  mkskin(ifpdb,fpdb2,im,jm,km,h,xo,yo,zo,np2,isk2)
c
ccc
                DO ipart=1,npart
      do 421 i=1,im   
      do 422 j=1,jm   
      do 423 k=1,km   
      isk1a(i,j,k)=isk1(i,j,k)
      isk2a(i,j,k)=isk2(i,j,k)
 423  continue
 422  continue
 421  continue
                 do m=1,3
                 r1(m)= xr1(m,ipart)
                 r2(m)= xr2(m,ipart)
                 end do
                 scarr  = ar(ipart)
                 write(iulog,'(7f8.3)') 
     ,r1,r2(1)-r1(1),r2(2)-r1(2),r2(3)-r1(3),scarr
 609  format(a ,a,' ',a)
 610  format(a)
      if (dopdbvol) then
       write(ipdbvol,609) 'HEADER',TRIM(fpdb1),TRIM(fpdb2)
c       write(ipdbvol,609),'MODEL',TRIM(fpdb1),TRIM(fpdb2)
      end if
                call rebuild(im,jm,km,h,xo,yo,zo,
     ,          r1,r2,scarr,isk1a,isk2a)
      if (dopdbvol) then
       write(ipdbvol,610) 'TER'
c       write(ipdbvol,610),'ENDMDL'
      end if
      call rearra(grid1,grid2,im,jm,km,h,
     &                  xo,yo,zo,isk1a,isk2a,np1a,np2a,
     &                  npoi,aa,bb,ab,aa0,bb0)
	  write(iulog,611) im,jm,km,h,xo,yo,zo
	  write(iulog,*) 'No of points on skin:',npoi
 611  format('grid dimensions:  ',i3,2('.',i3),'  spacing:',f8.3,/,
     ,'grid origin:',3f8.3)
       pnp12=float(np1a)*float(np2a)
       write(6,612) 2*ab/(aa+bb),ab/sqrt(aa*bb),aa,bb,ab,aa0,bb0
     ,,2.*float(npoi)/float(np1a+np2a)
     ,,float(npoi)/sqrt(pnp12),np1a,np2a,npoi
                 END DO
 612  format(2f7.3,5e15.7,2f7.3,3i7)
c
 1000  continue
      stop
   79 format(6e15.5)
   80 format(e15.5)
   81 format(3f8.2)
   83 format(10f8.3)
c
      end
      subroutine rearra(grid1,grid2,im,jm,km,h,
     &                  xo,yo,zo,isk1,isk2,np1a,np2a,
     &                  npoi,aa,bb,ab,aa0,bb0)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      include "maxdim.inc"
      integer im, jm, km
	  integer*1 isk1(im_max,im_max,im_max)
	  integer*1 isk2(im_max,im_max,im_max)
      dimension grid1(1)
      dimension grid2(1)
      double precision daa,dbb,dab
      double precision daa0,dbb0
      common/ius/iulog
c
              write(iulog,81) xo, yo, zo
   81 format('rearrangement routine, grid origin:',3f8.3)
c
c ijk transform to n as n=i+(j-1)*im+(k-1)*im*jm
      imjm=im*jm
	  npoi=0
	  np1a=0
	  np2a=0
	  g1max=-1.e+20
	  g1min= 1.e+20
	  g2max=-1.e+20
	  g2min= 1.e+20
       daa=0.d0
       dbb=0.d0
       dab=0.d0
       daa0=0.d0
       dbb0=0.d0
      do 421 i=1,im   
      do 422 j=1,jm   
      do 423 k=1,km   
      nn=i+(j-1)*im+(k-1)*imjm
      if(isk1(i,j,k).ne.0) then
        daa0=daa0+grid1(nn)**2
        np1a=np1a+1
      end if
      if(isk2(i,j,k).ne.0) then
         dbb0=dbb0+grid2(nn)**2
         np2a=np2a+1
      end if
      if(isk1(i,j,k).eq.0) goto 410
      if(isk2(i,j,k).eq.0) goto 410
      npoi=npoi+1
      daa=daa+grid1(nn)**2 
      dbb=dbb+grid2(nn)**2 
      dab=dab+grid1(nn)*grid2(nn)
	  if(grid1(npoi).gt.g1max) g1max=grid1(nn)
	  if(grid1(npoi).lt.g1min) g1min=grid1(nn)
	  if(grid2(npoi).gt.g2max) g2max=grid2(nn)
	  if(grid2(npoi).lt.g2min) g2min=grid2(nn)
 410  continue
 423  continue
 422  continue
 421  continue
       aa=daa 
       bb=dbb 
       ab=dab 
       aa0=daa0
       bb0=dbb0
              write(iulog,82) g1min, g1max
              write(iulog,82) g2min, g2max
   82 format('rearrangement routine, grid minmax:',2e11.3)
      return
      end
      subroutine inpgrd( filnam,iounit,iform,im,jm,km,
     &                   h,ox,oy,oz,grid) 
      include "maxdim.inc"
c
c. This is essentially a copy from UHBD version 4.1
      character*40 filnam
      integer iounit, iform
      character*72 title
      integer im, jm, km
	  dimension grid(1)
      integer grdflg
      integer stderr
      common/ius/iulog
c
      real dum2, dum3, dum4, dum5, dum6, dum7, dum8
      integer idum1, idum2, idum3, idum4, idum5, idum6, idum7
      integer i, j, k, l, kx
      real xbuf(im_max*im_max*2)
	  stderr=6
c
      if ( iform .eq. 0 ) then
         open(iounit, file=filnam, form='unformatted', status='old' )
         read(iounit) title, scale, dum2, idum1, idum2,
     &                idum3, idum4, idum5, im, jm, km,
     &                h, ox, oy, oz,
     &                dum3, dum4, dum5, dum6, dum7, dum8, idum6, idum7
         if ( im*jm .gt. im_max*im_max*2 ) then
            write(stderr,99001)
            stop
c???
c???
         endif
         if ( im*jm*km .gt. im3_max ) then
            write(stderr,99002)
            stop
         endif
         do  10  k = 1 , km
            read(iounit) kx, im, jm
            read(iounit) (xbuf(l), l = 1 , im*jm)
            do  9  l = 1 , im*jm
c              grid((k-1)*im*jm+l) = xbuf(l) / scale
               grid((k-1)*im*jm+l) = xbuf(l)        
    9       continue
   10    continue
         close(iounit)
      else if ( iform .eq. 1 ) then
         open( iounit, file=filnam, form='formatted', status='old' )
         read(iounit,77) title, scale, dum2, idum1, idum2,
     &                   idum3, idum4, idum5, im, jm, km,
     &                   h, ox, oy, oz,
     &                   dum3, dum4, dum5, dum6, dum7, dum8,
     &                   idum6, idum7
         if ( im*jm*km .gt. im3_max ) then
            write(stderr,99002)
            stop
         endif
         do  20  k = 1 , km
            read(iounit,78) kx, im, jm
            read(iounit,79) ( grid((k-1)*im*jm+l), l=1,im*jm )
   20    continue
         close(iounit)
      endif
      return
c
c..........
c
c               Format statements.
c
   77 format(a72/2e12.6,5i7/3i7,4e12.6/4e12.6/2e12.6,2i7)
   78 format(3i7)
   79 format( (6(1x,e12.6)) )
99001 format(1x,'FATAL: inpgrd(001) buffer too small.' )
99002 format(1x,'FATAL: inpgrd(002) grid too large. ',
     .          'recompile with larger im_max value.' )
      end
	  subroutine mkskin(ifpdb,fpdb,im,jm,km,h,xo,yo,zo,npp,isk)
      include "maxdim.inc"
      character*80 string
	  character*40 fpdb
	  character*4 atom
	  character*1 an
	  dimension xv(3)
	  character*1 iexsk(im_max),chex,chsk,chsp
c. this array is an internal
	  integer*1 iex(im_max,im_max,im_max)
c. this is supposed to be used later
	  integer*1 isk(im_max,im_max,im_max)
      common/ius/iulog
	  common/probc/probes,skin
	  data atom /'ATOM'/,chex,chsk,chsp/' ','x',' '/
c---
c
      do 301 i=1,im_max
      do 302 j=1,im_max
      do 303 k=1,im_max
      iex(i,j,k)=0
      isk(i,j,k)=0
 303  continue
 302  continue
 301  continue
c
	  write(iulog,*)
	  write(iulog,*) 'Constructing fitting region...'
      open(ifpdb,file=fpdb,form='formatted',status='old')
      dexcl=h
	  rexmax=1.9d0+probes
      hdexcl=dexcl/2.d0
      klim=int((rexmax+dexcl*1.5d0)/dexcl)
c		xexh=xo-hdexcl
c		yexh=yo-hdexcl
c		zexh=zo-hdexcl
		xexh=xo
		yexh=yo
		zexh=zo
c---find the center of the protein 
      natoms=0
	  npoi=0
 1    continue
	  read(ifpdb,500,end=99) string
	  if(string(1:4).ne.atom) goto 1
      read(string(1:54),501) an,xv
 500  format(a)
 501  format(13X,A1,16X,3F8.3)
      natoms=natoms+1
        call van(an,probes,rexcl2)
        rexcl=sqrt(rexcl2)
        x1=xv(1)
        x1a=x1+hdexcl  
        x2=xv(2)
        x2a=x2+hdexcl  
        x3=xv(3)
        x3a=x3+hdexcl  
C          FIND HOME GRID CELL IH,JH,KH
        ih=(x1a-xo)/dexcl
		jh=(x2a-yo)/dexcl
		kh=(x3a-zo)/dexcl
C
        DO 423 KK=-KLIM,KLIM
        K=KK+KH
        IF(k.le.0.or.k.gt.km)GOTO 423
c..here and further we correct the shifting by hdexcl:
c        ZK=dfloat(K)*dexcl-hdexcl+zo
c..here is a concerted change with change in exchk.f
        ZK=dfloat(K)*dexcl+zo
        ZTEMP = ZK - X3
        IF(ZTEMP.GT.rexcl)GOTO 423
                DO 422 JJ=-KLIM,KLIM
                J=JJ+JH
                IF(j.le.0.or.j.gt.jm)GOTO 422
                YJ=dFLOAT(J)*dexcl +yo
                YTEMP = YJ - X2
                IF(YTEMP.GT.rexcl)GOTO 422
                        DO 421 II=-KLIM,KLIM
                        I=II+IH
                        IF(i.le.0.or.i.gt.im)GOTO 421
                        IF(IEX(I,J,K).EQ.1)GOTO 421
                        XI=dFLOAT(I)*dexcl +xo
                        XTEMP = XI - X1
                        DIST2 =
     &                  XTEMP * XTEMP + YTEMP * YTEMP + ZTEMP * ZTEMP
                        IF(DIST2.GT.rexcl2)GOTO 421
                        IEX(I,J,K)=1
						npoi=npoi+1
 421                    CONTINUE
 422            CONTINUE
 423    CONTINUE
      goto 1
 99   continue
CCC      CLOSE(UNIT=iusas)
	  dismx1=sqrt(dismx1)
	  write(iulog,602) natoms,npoi
 602  format('No of atoms used for excl grid       :',i6,/,
     ,       'No of points assigned value 1        :',i6)
CCC
CCC__version 2.23__ repeat now the same with increased by skin probe
      dexcl=h   
	  probsk=probes+skin
c..the first number is the maximal atom radius appearing in pdb
	  rexmax=1.9d0+probsk        
      hdexcl=dexcl/2.d0
      klim=(rexmax+dexcl*1.5d0)/dexcl
CCC..skip the center finding 
c---read pdb file
      rewind (ifpdb)
      natosk=0
	  npoisk=0
 11   continue
	  read(ifpdb,500,end=991) string
	  if(string(1:4).ne.atom) goto 11
      read(string(1:54),501) an,xv
      natosk=natosk+1
        call van(an,probsk,rexcl2)
        rexcl=sqrt(rexcl2)
        x1=xv(1)
        x1a=x1+hdexcl  
        x2=xv(2)
        x2a=x2+hdexcl  
        x3=xv(3)
        x3a=x3+hdexcl  
C          FIND HOME GRID CELL IH,JH,KH
        ih=(x1a-xo)/dexcl
		jh=(x2a-yo)/dexcl
		kh=(x3a-zo)/dexcl
C
        DO 4231 KK=-KLIM,KLIM
        K=KK+KH
        IF(k.le.0.or.k.gt.km)GOTO 4231
c..here and further we correct the shifting by hdexcl:
c        ZK=dfloat(K)*dexcl-hdexcl+oez
c..here is a concerted change with change in exchk.f
        ZK=dfloat(K)*dexcl+ zo
        ZTEMP = ZK - X3
        IF(ZTEMP.GT.rexcl)GOTO 4231
                DO 4221 JJ=-KLIM,KLIM
                J=JJ+JH
                IF(j.le.0.or.j.gt.jm)GOTO 4221
                YJ=dFLOAT(J)*dexcl + yo
                YTEMP = YJ - X2
                IF(YTEMP.GT.rexcl)GOTO 4221
                        DO 4211 II=-KLIM,KLIM
                        I=II+IH
                        IF(i.le.0.or.i.gt.im)GOTO 4211
                        IF(IEX(I,J,K).EQ.1)GOTO 4211
                        IF(ISK(I,J,K).EQ.1)GOTO 4211
                        XI=dFLOAT(I)*dexcl + xo
                        XTEMP = XI - X1
                        DIST2 =
     &                  XTEMP * XTEMP + YTEMP * YTEMP + ZTEMP * ZTEMP
                        IF(DIST2.GT.rexcl2)GOTO 4211
                        ISK(I,J,K)=1
						npoisk=npoisk+1
 4211                   CONTINUE
 4221           CONTINUE
 4231   CONTINUE
      goto 11
 991  continue
      CLOSE(UNIT=ifpdb)

	  write(iulog,6021) natosk,npoisk
      npp=npoisk
 6021 format('No of atoms used for prot 1 excl+skin grid:',i6,/,
     ,       'No of points assigned value 1             :',i6)
CCC__version 2.23__ repeat ends                                     
CCC
CCC...Now write the prot1 ptofile 
      WRITE(iulog,603)
 603  format('A cross section of excl. grid of pr. #1, xOy plane',/)
      K=km/2
	  jskip=(jm-78)/2
	  if(jskip.lt.0) jskip=0 
	  iskip=(im-78)/2
	  if(iskip.lt.0) iskip=0 
      DO J=jskip+1,jm-jskip
		do 12 i=1,im
        iexsk(i)=chsp
		if(isk(i,j,k).eq.1) iexsk(i)=chsk
		if(iex(i,j,k).eq.1) iexsk(i)=chex
 12     continue
      WRITE(iulog,13)(iexsk(i),i=iskip+1,im-iskip)
      CONTINUE
 13   FORMAT(80a1)  
      END DO
	  write(iulog,*)
      RETURN
      END
      subroutine van(a,srad,v)
      character*1 a
c..These are OPLS parameters used in UHBD
      V=1.9  !DEFAULT VDW RADIUS
      IF(A.EQ.'H')V=1.20
      IF(A.EQ.'E')V=1.200
      IF(A.EQ.'C')V=1.90
      IF(A.EQ.'N')V=1.625
      IF(A.EQ.'O')V=1.48
      IF(A.EQ.'P')V=1.90
      IF(A.EQ.'S')V=1.85
      IF(A.EQ.'F')V=0.64  !ASSUMES FE
      IF(A.EQ.'Z')V=1.38  !ASSUMES ZN
      IF(A.EQ.'B')V=1.95  !ASSUMES BR
      IF(A.EQ.'I')V=2.15
      V=V+SRAD  !ADD PROBE RADIUS
      V=V*V
      RETURN
      END
      subroutine rebuild(im,jm,km,h,xo,yo,zo,
     ,          xr1,xr2,scarr,isk1a,isk2a)
      include "maxdim.inc"
      integer im, jm, km
      integer*1 isk1a(im_max,im_max,im_max)
      integer*1 isk2a(im_max,im_max,im_max)
c      double precision theta,dxyz,dxy
c c: costheta, s sintheta, v: versin (1-cos)        
c      double precision c,s,v
c norms of the rotation vector
c      double precision X,Y,Z,rndx
c values of rotation matrix
c      double precision d11,d12,d13,d21,d22,d23,d31,d32,d33
c Coordinate system will be translated and rotated
c translation, such that xr1 is 0/0/0 in new system
c rotation arround xr1, such that xr2 is 0/0/t
c xr1 and xr2 are the start and endpoint of cylinder
c xrs1 and xrs2 is the same, where xrs1 is moved to origin
c rotvec is the perpendicular to the plane along to rotate
c rn is the normalized rotation vector.
c rp is the rotated xrs2
      dimension xr1(3),xr2(3),xrs1(3),xrs2(3),rotvec(3),rn(3),rp(3)
      common/ius/iulog
      common/writePDB/dopdbvol,ipdbvol
      LOGICAL dopdbvol

      do l=1,3
         xrs1(l)=xr1(l)-xr1(l)
         xrs2(l)=xr2(l)-xr1(l)
      end do
      dxyz=sqrt(xrs2(1)**2+xrs2(2)**2+xrs2(3)**2)
      dxy=sqrt(xrs2(1)**2+xrs2(2)**2)
c analog to http://paulbourke.net/geometry/rotate/
c and       http://paulbourke.net/geometry/rotate/PointRotate.py
c z-axis and translated xr2 (xrs2) span a plane
c we rotate the system around the normal to this
c plane, such that the axis xr1-xr2 becomes the z axis
c Then we can easily evaluate the cylinder.
c The rotation vector is the cross product of the 
c vector xrs2 and (0,0,1). The order depends on the sign of the
c angle. Otherwise the -1 needs to go on the first coordinate 
c below. The rotation angle theta itself is
c sin(theta)=dxy/dxyz
c cos(theta)=xrs2(3)/dxyz
c sin(theta)
      s=dxy/dxyz
c cos(theta)
      c=xrs2(3)/dxyz
c versin(theta)
      v=1-c
      rotvec(1)=xrs2(2)    
      rotvec(2)=-1*xrs2(1)
      rotvec(3)=0.0
      rndx=sqrt(rotvec(1)**2+rotvec(2)**2+rotvec(3)**2)
c      Write(*,*),'xr1',xr1(1),xr1(2),xr1(3)
c      Write(*,*),'xr2',xr2(1),xr2(2),xr2(3)
c      Write(*,*),'xrs2',xrs2(1),xrs2(2),xrs2(3)
c      Write(*,*)'dxy, dxyz',dxy,dxyz
c      Write(*,*)'rndx,rotvec: ',rndx,rotvec(1)
c      call exit(1)
      if (rndx.eq.0) then 
        rn(1)=0
        rn(2)=0
        rn(3)=0
      else
        rn(1)=rotvec(1)/rndx
        rn(2)=rotvec(2)/rndx
        rn(3)=rotvec(3)/rndx
      end if
      X=rn(1)
      Y=rn(2)
      Z=rn(3)
      d11=v*X**2 + c
      d12=v*X*Y - s*Z
      d13=v*X*Z + s*Y
      d21=v*X*Y + s*Z
      d22=v*Y**2 + c
      d23=v*Y*Z - s*X
      d31=v*X*Z - s*Y
      d32=v*Y*Z + s*X
      d33=v*Z**2 + c
      rp(1)=d11*xrs2(1)+d12*xrs2(2)+d13*xrs2(3)
      rp(2)=d21*xrs2(1)+d22*xrs2(2)+d23*xrs2(3)
      rp(3)=d31*xrs2(1)+d32*xrs2(2)+d33*xrs2(3)
c      Write(*,*),'Rotated point',rp(1),rp(2),rp(3)
      do 421 i=1,im   
      do 422 j=1,jm   
      do 423 k=1,km   
          if((isk1a(i,j,k).eq.0).and.
     ,       (isk2a(i,j,k).eq.0)) goto 410
          xxx=i*h+xo
          yyy=j*h+yo
          zzz=k*h+zo
          xx=i*h+xo-xr1(1)
          yy=j*h+yo-xr1(2)
          zz=k*h+zo-xr1(3)
          xxa=d11*xx+d12*yy+d13*zz
          yya=d21*xx+d22*yy+d23*zz
          zza=d31*xx+d32*yy+d33*zz
c          Write(*,*),'Dealing with',xx,yy,zz
            if(zza .gt. dxyz.or.zza.lt.0.0) then
              isk1a(i,j,k)=0
              isk2a(i,j,k)=0
               goto 410
c              Write(*,*),'Converting above',xx,yy,zz
            end if
c            if(rp(3) .lt. 0.0) then
c             isk1a(i,j,k)=0
c              isk2a(i,j,k)=0
c              Write(*,*),'Converting below',xx,yy,zz
c            end if
            if(xxa**2+yya**2 .gt. scarr**2) then
              isk1a(i,j,k)=0
              isk2a(i,j,k)=0
c              Write(*,*),'Radius above condition',xxa,yya,zza
               goto 410
            end if
c            if (.NOT.PDBvolExists) then
 409  Format(A6,I5,A1,A4,A1,A3,A1,A1,I4,A1,
     +3X,3F8.3,2F6.2)
            if (isk1a(i,j,k)==1.and.isk2a(i,j,k)==1.and.dopdbvol) then
            Write(ipdbvol,409) 'HETATM',1,' ','X',' ','X',' ',' ',1,' ',
     +xxx,yyy,zzz,1.0,1.0
c            Write(ipdbvol,409),'HETATM',1,' ','X',' ','X',' ',' ',1,' ',
c     +xxa,yya,zza,1.0,1.0
c            end if
c'HETATM      1  X     X    1      ',xx,yy,zz
            end if
 410  continue
 423  continue
 422  continue
 421  continue
      return
      end

c----------------------------------------------------------------------
c  program mkdismx     
c  PIPSA version 3.0 (Jan 2007)          
c
c  Authors: R.R.Gabdoulline, R.C.Wade
c  Copyright (c) 2004
c  EML Research gGmbH, Schloss-Wolfsbrunnenweg 33, 69118 Heidelberg,
c  Germany, and
c  European Molecular Biology Laboratory, Heidelberg, Germany
c
c  This copyright notice must be attached to all copies, or extracts,
c  of this software.
c
c  Please obtain a license before using this software from the PIPSA
c  website or "rebecca.wade@eml-r.villa-bosch.de".
c  Conditions of usage are as specified in the license agreement.
c
c  Queries about problems with this software should be addressed to
c  "razif.gabdoulline@eml-r.villa-bosch.de".
c
c  References:
c  N. Blomberg, R.R. Gabdoulline, M. Nilges and R. C. Wade.
c   Classification of protein sequences by homology modeling and
c   quantitative analysis of electrostatic similarity.
c   Proteins: Str., Function and Genetics, 37:379-387 (1999)
c  Wade,R.C., Gabdoulline, R.R. and De Rienzo, F.
c   Protein Interaction Property Similarity Analysis
c   Intl. J. Quant. Chem., 83:122-127 (2001).
c----------------------------------------------------------------------
c
      implicit real*8 (a-h,o-z)
c. 
c. this version reads one of 14 results
c..
c.. reads from a single file :
c.. pair of names, 
c.. the matrix of ab,aa,bb, converts this to d(ab)
c.. convert d(ab)'s to 3D coordinates and writes in
c.. kinemage format
c..
      include "maxdim.inc"
      dimension dab1(nprmx2),xx(3,nprmx)
      character*40 argument
      character*30 pname1(nprmx2),pnamer
      character*30 pnames(nprmx,nprmx),pnamew
      dimension dab(nprmx,nprmx)
      dimension xav(3)
      real*8 dum(2)
      real*8 ans1,ans
c        
      call getarg(1,argument)
      read(argument(1:40),'(i40)') inom
      call getarg(2,argument)
      read(argument(1:40),'(i40)') nnom
c      write(6,*) ' analysing part #', inom,' of',nnom
c
      read(5,'(1x,i6)',end=99) np
      is1=0
 1    continue
      read(5,'(a)',end=99) pnamer
        do iom=1,inom-1
        read(5,*)
        end do
      read(5,*,end=99) si_h,si_c,aa,bb,ab,aa0,bb0
        do iom=inom+1,nnom
        read(5,*)
        end do
      is1=is1+1
      pname1(is1)=pnamer
c. distance based on norms at the intersection of skins
c      dab1(is1)=dsqrt(aa+bb-2.d0*ab)
c. distance based on norms on the whole skins
c      dab1(is1)=dsqrt(aa0+bb0-2.d0*ab)
c. distance based on similarity index
      dab1(is1)=dsqrt(2.d0-2.d0*si_c)
      goto 1
 99   continue
c
c       write(6,*) ' matrix read'
c
       ns1=is1
       ns1c=(np*np+np)/2 
       ns=np
       if(ns1c.ne.ns1) then
       write(6,*) ' bad matrix: expected',ns1c,'  points'
       write(6,*) 'got:', ns1,'  - please correct'
       goto 999
       end if
c
         fmax=0.0d0
         i1max=1
         i2max=2
       is1=0
       do i1=1,ns
       do i2=1,i1
       is1=is1+1
c       is1=i1+(i2-1)*ns
       dab(i1,i2)=dab1(is1)
       dab(i2,i1)=dab1(is1)
         if(dab(i1,i2).gt.fmax) then
         fmax=dab(i1,i2)
         i1max=i1
         i2max=i2
         end if
       pnames(i1,i2)=pname1(is1)
       end do 
       end do 
c
      do i=1,ns
      write(6,611) (dab(i,j),j=1,ns)
      end do
 611  format(999f8.3)
 999  continue
c
      call exit
      end 
c
      subroutine namelength(name,lpn)
      implicit real*8 (a-h,o-z)
      parameter (n30=30)
      character*30 name
      character*1 sp
      data sp/' '/
c
      ke=n30+1
      do k=1,n30
      if(name(k:k).eq.sp) then
      ke=k
      goto 41
      end if
      end do
 41   continue
      lpn=ke-1
      return
      end
      subroutine nameclear(name)
      implicit real*8 (a-h,o-z)
      parameter (n30=30)
      character*30 name
      character*1 sp
      data sp/' '/
c
      ke=n30+1
      do k=1,n30
      if(name(k:k).eq.sp) then
      ke=k
      goto 41
      end if
      end do
 41   continue
      do k=ke,n30
      name(k:k)=sp
      end do
      return
      end

c----------------------------------------------------------------------
c  program mkgridin    
c  PIPSA version 3.0 (Jan 2007)          
c
c  Authors: R.R.Gabdoulline, R.C.Wade
c  Copyright (c) 2004
c  EML Research gGmbH, Schloss-Wolfsbrunnenweg 33, 69118 Heidelberg,
c  Germany, and
c  European Molecular Biology Laboratory, Heidelberg, Germany
c
c  This copyright notice must be attached to all copies, or extracts,
c  of this software.
c
c  Please obtain a license before using this software from the PIPSA
c  website or "rebecca.wade@eml-r.villa-bosch.de".
c  Conditions of usage are as specified in the license agreement.
c
c  Queries about problems with this software should be addressed to
c  "razif.gabdoulline@eml-r.villa-bosch.de".
c
c  References:
c  N. Blomberg, R.R. Gabdoulline, M. Nilges and R. C. Wade.
c   Classification of protein sequences by homology modeling and
c   quantitative analysis of electrostatic similarity.
c   Proteins: Str., Function and Genetics, 37:379-387 (1999)
c  Wade,R.C., Gabdoulline, R.R. and De Rienzo, F.
c   Protein Interaction Property Similarity Analysis
c   Intl. J. Quant. Chem., 83:122-127 (2001).
c----------------------------------------------------------------------
c
c: Command File for Programme GRID
c: Channel Numbers and Output File names:
c LONT      6
c LONT  gridlont.dat                                                            
c KONT     20
c KONT  gridkont.dat                                                            
c: Channel Numbers and Input File names:
c INPT     10
c INPT  grinkout.dat                                                            
c: Control Parameters:
c CLER      5.000 
c DEEP      5.000 
c DPRO      4.000 
c DWAT     80.000 
c EACH      5.000 
c EMAX      5.000 
c FARH      5.000 
c FARR      8.000 
c KWIK      0     
c LEAU      0     
c LENG     12     
c LEVL      0     
c LIST      1     
c MOVE      0     
c NETA      1    
c NPLA      1     
c NUMB      1  
c VALU      0.000 
c DRY           
c TOPX     76.467 
c TOPY     66.882
c TOPZ     66.678
c BOTX    -33.533
c BOTY    -43.118
c BOTZ    -43.322
c IEND
c GRIG 1 A spacing, size - from top and botss
c       0    1
c:PROG:  /wade/wade3/owl2/local/gri17/grid
c:DEFA:                                                                         
c. reads the file center.log and writes grid.in
      character*41 string
      character*1 key
      character*256 fgridin,arg,probe
      data key/'#'/
c
      call getarg(1,arg) 
      if(arg(1:2).eq.'-h') then
      write(6,499)
 499  format('usage: mkgridin -fg grid.in -pr GRID_PROBE_NAME',
     ,' < center.log')
      call exit
      end if
c
      fgridin='grid.in'
      probe='PO4' 
c
      nargs=iargc()
      do ia=1,nargs-1
      call getarg(ia,arg)
      if(arg(1:3).eq.'-fg') then
      call getarg(ia+1,fgridin)
      end if
      if(arg(1:3).eq.'-pr') then
      call getarg(ia+1,probe)
      end if
      end do
      call slen(probe,npr)
c
      xa=0.0
      ya=0.0
      za=0.0
      da=0.0
      dmax=0.0
      ic=0
 1    continue
      read(5,'(a)',end=99) string
      if(string(1:1).ne.key) goto 1
      ic=ic+1 
      read(string(1:41),601) 
     r     xic,yic,zic,dic
      xa=xa+xic
      ya=ya+yic
      za=za+zic
      da=da+dic
      if(dic.gt.dmax) dmax=dic
      goto 1
 99   continue
      nc=ic
      xa=xa/float(nc)
      ya=ya/float(nc)
      za=za/float(nc)
      da=da/float(nc)
c
c. grid size is 65^3, spacing 1 A, no checks in this version
c
      imax=65
      half=float(imax-1)/2.0
      tx=xa+half
      ty=ya+half
      tz=za+half
      bx=xa-half
      by=ya-half
      bz=za-half
      open(77,file=fgridin)
      write(77,602) probe(1:npr),tx,ty,tz,bx,by,bz
      close(77)
c
 601  format(1x,3f8.3,8x,f8.3)
 602  format(
     ,': Command File for Programme GRID',/,
     ,': Channel Numbers and Output File names:'/,
     ,' LONT       6',/,' LONT  gridlont.dat'/,
     ,' KONT      20',/,' KONT  gridkont.dat',/,
     ,': Channel Numbers and Input File names:',/,
     ,' INPT      10',/,' INPT  grinkout.dat',/,
     ,': Control Parameters:',/,
     ,' CLER     5.000',/,' DEEP     5.000',/,
     ,' DPRO     4.000',/,' DWAT    80.000',/,
     ,' EACH     5.000',/,' EMAX     5.000',/,
     ,' FARH     5.000',/,' FARR     8.000',/,
     ,' KWIK     0'    ,/,' LEAU     0',/,
     ,' LENG    12'    ,/,' LEVL     0',/,
     ,' LIST     1'    ,/,' MOVE     0'    ,/,
     ,' NETA     1'    ,/,' NPLA     1'    ,/,
     ,' NUMB     1'    ,/,' VALU     0.000',/,
     ,' ',a,/,
     ,' TOPX ',f8.3,/,' TOPY ',f8.3,/,' TOPZ ',f8.3,/,
     ,' BOTX ',f8.3,/,' BOTY ',f8.3,/,' BOTZ ',f8.3,/,
     ,' IEND',/,
     ,' GRID 1 A spacing, size - from top and bots',/,
     ,'       0    1',/,
     ,':PROG:  /wade/wade3/owl2/local/gri17/grid',/,
     ,':DEFA:'
     ,)
c
 999  continue
      call exit
      end
      subroutine slen(s,ns)
      character*256 s
      do i=256,1,-1
      ns=i
      if(s(i:i).ne.' ') return
      end do
      return
      end

c Reads kinemage and highlights in red the proteins 
c which names are given in the command line 
      character*128 s,se,namh(999),sa(999),namt
      dimension x(3,999)
c
      do i=1,128
      se(i:i)=' '
      end do
c
      nh=iargc()
      if(nh.lt.1) then
      write(6,*) 'usage: highlight_kin_points pname1 pname2 ...',
     ,' < in.kin > out.kin' 
      call exit
      end if
c
      do ih=1,nh
      call getarg(ih,namh(ih))
      end do
c
      np=0
 1    continue
      read(5,'(a)',end=99) s
      if(s(1:6).eq.'@balll') goto 91
      call slen(s,ns)
      write(6,'(a)') s(1:ns)
      goto 1
 91   continue
c. read coordinates
      np=0
 2    continue
      read(5,'(a)',end=92) s
      np=np+1
      sa(np)=s
      goto 2
 92   continue
c
      do ih=1,nh
      namt=namh(ih)
      call slen(namt,nnamt)
      write(6,501) namt(1:nnamt)
        do ip=1,np
        s=sa(ip)
        ll=nnamt+5
        if(s(6:ll).eq.namt(1:nnamt)) then
        call slen(s,ns)
        write(6,'(a)') s(1:ns)
        end if
        end do
      end do
 501  format('@balllist {',a,'} color =red radius = 0.016')
      write(6,502)
      do ip=1,np
      s=sa(ip)
        call slen(s,ns)
        write(6,'(a)') s(1:ns)
      end do
 502  format('@balllist {ALL} color =white radius = 0.008')
c
 99   continue
      call exit
      end
      subroutine slen(s,ns)
      character*128 s
      do i=128,1,-1
      ns=i
      if(s(i:i).ne.' ') return
      end do
      return
      end

c----------------------------------------------------------------------
c  program whatif2uhbd 
c  PIPSA version 3.0 (Jan 2007)          
c
c  Authors: R.R.Gabdoulline, R.C.Wade
c  Copyright (c) 2004
c  EML Research gGmbH, Schloss-Wolfsbrunnenweg 33, 69118 Heidelberg,
c  Germany, and
c  European Molecular Biology Laboratory, Heidelberg, Germany
c
c  This copyright notice must be attached to all copies, or extracts,
c  of this software.
c
c  Please obtain a license before using this software from the PIPSA
c  website or "rebecca.wade@eml-r.villa-bosch.de".
c  Conditions of usage are as specified in the license agreement.
c
c  Queries about problems with this software should be addressed to
c  "razif.gabdoulline@eml-r.villa-bosch.de".
c
c  References:
c  N. Blomberg, R.R. Gabdoulline, M. Nilges and R. C. Wade.
c   Classification of protein sequences by homology modeling and
c   quantitative analysis of electrostatic similarity.
c   Proteins: Str., Function and Genetics, 37:379-387 (1999)
c  Wade,R.C., Gabdoulline, R.R. and De Rienzo, F.
c   Protein Interaction Property Similarity Analysis
c   Intl. J. Quant. Chem., 83:122-127 (2001).
c----------------------------------------------------------------------
c
      program whatif2uhbd
      implicit real*4 (a-h,o-z)
c
c originally written by V. Lounnas
c additions by RRG
c will work only for a single chain proteins !!!
c waters are however permitted
c
      character*4 wrkres,wrkres0,wrkres1,wrkat,wrkat0,wrkat1
      character*4 atom,hid,hie,hip,hit
      character*5 wresi
      character*66 line,linet
      character*66 lines(17)
      logical endfil
      data atom/'ATOM'/
      data hid/'HID '/,hie/'HIE '/,hip/'HIP'/
c
      open(12,file='tmp.pdb',form='formatted',status='unknown')
c
      wrkat1 = ' ** '
      wresi  = ' ** '
      ifirst=0
10    read(5,100,end=999) line 
      if(line(1:4).ne.atom) then
      write(12,100) line
      goto 10
      end if
      if(ifirst.eq.0) then
      ifirst=1
      read(line(22:26),'(1x,i4)') irmin
      end if
      wrkres = line(18:21)
      wrkat  = line(13:16) 
      if(wrkat(2:3).eq.'O2') then
      write(line(22:26),'(a)') wresi
      read(wresi(1:5),'(1x,i4)') irmax
      else
      if(line(18:21).ne.'HOH ') wresi  = line(22:26)
      end if
c
      if(wrkat(2:2).ne.'C'.and.wrkat(2:2).ne.'N'.and.
     +   wrkat(2:2).ne.'O'.and.wrkat(2:2).ne.'S') then 
c      wrkat0 = ' H  '
c
      wrkat0 = ' H'//wrkat1(3:3)
c      if(wrkat1(2:2).eq.'N') then
         if(wrkat1(4:4).ne.' ') then 
         wrkat0 = ' H'//wrkat1(3:4)
         endif
c      endif
c
      if(wrkat1(2:2).eq.'N'.and.wrkat1(3:3).ne.' '.and.
     +   wrkat1(4:4).eq.' ') then 
      wrkat0 = wrkat0(1:3)//'1'
      endif
c
      if(wrkat1(2:3).eq.'OW') then 
      wrkat0 = wrkat0(1:3)//'1'
      endif
c
      if(wrkat1(2:2).eq.'H'.and.wrkat1(4:4).eq.'1') then
      wrkat0 = wrkat0(1:3)//'2'
      endif
c
      if(wrkat1(2:2).eq.'H'.and.wrkat1(4:4).eq.'2') then
      wrkat0 = wrkat0(1:3)//'3'
      endif
c
c
      if(wrkat1(2:2).eq.'N'.and.wrkat1(3:3).ne.' '.and.
     +   wrkat1(4:4).ne.' ') then    
      wrkat0(1:4) = wrkat0(2:4)//'1'
      endif
c
      if(wrkat1(1:1).eq.'H'.and.wrkat1(4:4).eq.'1') then
      wrkat0(1:4) = wrkat1(1:3)//'2'
      endif
c
c particular cases:
c      
      if(wrkat1(2:4).eq.'NE1') then 
      wrkat0 = ' HE1'
      endif
c
      if(wrkat1(2:4).eq.'OE2') then 
      wrkat0 = ' HE '
      endif
c
      if(wrkat1(2:4).eq.'OD2') then 
      wrkat0 = ' HD '
      endif
c
      if(wrkat1(2:4).eq.'OD1'.and.wrkat0(2:3).eq.'HD') then
      wrkat0 = ' HD '
      endif
c
      if(wrkat1(2:4).eq.'OE1'.and.wrkat0(2:3).eq.'HE') then
      wrkat0 = ' HE '
      endif
c
      if(wrkat1(2:4).eq.'NE ') then
      wrkat0 = ' HE '
      endif
c
      if(wrkres(1:3).eq.'HIS'.and.wrkat1(2:4).eq.'NE2') then
      wrkat0 = ' HE2'
      endif
c
      if(wrkres(1:3).eq.'HIS'.and.wrkat1(2:4).eq.'ND1') then
      wrkat0 = ' HD1'
      endif
c
      if(wrkres(1:3).eq.'ASP'.and.wrkat1(2:4).eq.'OD1') then
      wrkat0 = ' HD1'
      endif
c
      if(wrkres(1:3).eq.'ASP'.and.wrkat1(2:4).eq.'OD2') then
      wrkat0 = ' HD2'
      endif
c
      else
      wrkat0 = wrkat
      endif
c
      write(12,101) line(1:12),wrkat0,' ',wrkres,line(22:66)
c      write(6,101) line(1:12),wrkat0,' ',wrkres,line(22:66)
c
      wrkat1  = wrkat0
      goto 10
c
999   continue 
c      write(6,*) irmin,irmax
c.. post processing (12) "tmp.pdb" - rename HIS to HID or HIE and NTRM and CTRM
      rewind (12) 
 11   continue
      read(12,100,end=99) line
 111  continue
      if(line(1:4).ne.atom) then
      write(6,100) line
      goto 11
      end if
c. no tracing for waters
      if(line(18:21).eq.'HOH ') then
      write(6,100) line
      goto 11
      end if 
c
c
c. trace HID or HIE
      if(line(18:21).ne.'HIS ') goto 15
c. here read anything
      endfil=.false.
      nn=1
      lines(nn)=line
      read(line(22:26),'(1x,i4)') irthis
 151  continue
      read(12,100,end=152) line
      read(line(22:26),'(1x,i4)') ir
      if(ir.ne.irthis) goto 153
      nn=nn+1 
      lines(nn)=line
      goto 151
 152  continue 
      endfil=.true.
 153  continue 
c
      itishd=0
      itishe=0
      do 161 ii=1,nn
      linet=lines(ii)
      if(linet(13:16).eq.' HE2') itishe=1
      if(linet(13:16).eq.' HD1') itishd=1
 161  continue
      hit=hid
      if(itishe.eq.1) then
      if(itishd.ne.1) hit=hie 
      if(itishd.eq.1) hit=hip
      end if
      do 171 ii=1,nn
      linet=lines(ii)
      write(linet(18:21),100) hit
      call term(linet,irmin,irmax)
      write(6,100) linet
 171  continue
c      
      if(endfil) goto 99
      goto 111
 15   continue
c. nothing special found
c. check for a terminal though
      call term(line,irmin,irmax)
      write(6,100) line
      goto 11
 99   continue
      close (12)
      stop
100   format(a)
101   format(a12,a4,a1,a4,a45)
200   format(4x,i7,1x,a5,a4,1x,i4,4x,3f8.3)
      end
      subroutine term(line,irmin,irmax)
      character*66 line
      character*4 atom,ntr,ntrm,ntrp,ctr,ctrm,ctrp
      data atom/'ATOM'/,ntrm/'NTRM'/,ctrm/'CTRM'/
      data ntrp/'NTRP'/,ctrp/'CTRP'/
c
c. trace the NTRM
      read(line(22:26),'(1x,i4)') ir
      if(ir.ne.irmin) goto 12
      ntr=ntrm
      if(line(18:21).eq.'PRO ') then
      ntr=ntrp
      if(line(14:15).eq.'CD') write(line(18:21),100) ntr
      end if
      if(line(14:15).eq.'H ') write(line(18:21),100) ntr
      if(line(14:15).eq.'N ') write(line(18:21),100) ntr
      if(line(14:15).eq.'CA') write(line(18:21),100) ntr
      if(line(14:15).eq.'C ') write(line(18:21),100) ntr
      if(line(14:15).eq.'O ') write(line(18:21),100) ntr
c      write(6,100) line
      goto 14
 12   continue
c. trace the CTRM
      if(line(14:15).ne.'O2') goto 13
      write(line(18:21),100) ctrm
c      write(6,100) line
      goto 14
 13   continue
      read(line(22:26),'(1x,i4)') ir
      if(ir.ne.irmax) goto 14
      ctr=ctrm
      if(line(18:21).eq.'PRO ') then
      ctr=ctrp
      if(line(14:15).eq.'CD') write(line(18:21),100) ctr
      end if
      if(line(14:15).eq.'N ') write(line(18:21),100) ctr
      if(line(14:15).eq.'H ') write(line(18:21),100) ctr
      if(line(14:15).eq.'CA') write(line(18:21),100) ctr
      if(line(14:15).eq.'C ') write(line(18:21),100) ctr
      if(line(14:15).eq.'O ') write(line(18:21),100) ctr
c      write(6,100) line
 14   continue
100   format(a)
      return
      end

c----------------------------------------------------------------------
c  program ccenter
c  PIPSA version 3.0 (Jan 2007)          
c
c  Authors: R.R.Gabdoulline, R.C.Wade
c  Copyright (c) 2004
c  EML Research gGmbH, Schloss-Wolfsbrunnenweg 33, 69118 Heidelberg,
c  Germany, and
c  European Molecular Biology Laboratory, Heidelberg, Germany
c
c  This copyright notice must be attached to all copies, or extracts,
c  of this software.
c
c  Please obtain a license before using this software from the PIPSA
c  website or "rebecca.wade@eml-r.villa-bosch.de".
c  Conditions of usage are as specified in the license agreement.
c
c  Queries about problems with this software should be addressed to
c  "razif.gabdoulline@eml-r.villa-bosch.de".
c
c  References:
c  N. Blomberg, R.R. Gabdoulline, M. Nilges and R. C. Wade.
c   Classification of protein sequences by homology modeling and
c   quantitative analysis of electrostatic similarity.
c   Proteins: Str., Function and Genetics, 37:379-387 (1999)
c  Wade,R.C., Gabdoulline, R.R. and De Rienzo, F.
c   Protein Interaction Property Similarity Analysis
c   Intl. J. Quant. Chem., 83:122-127 (2001).
c----------------------------------------------------------------------
c
c program reads max namx atoms
c it will not crash, but write a note if protein has more than nmax atoms
c
      include "maxdim.inc"
	  character*54 string
	  character*4 atom
	  data atom/'ATOM'/
      dimension xx(namx),yy(namx),zz(namx)
c
c      open(55,file='4ccenter.pdb')
      natom=0
	  xc=0.0
	  yc=0.0
	  zc=0.0
 1    continue
	  read(5,500,end=99) string
	  if(string(1:4).ne.atom) goto 1 
      read(string(31:54),501) x,y,z
      natom=natom+1
      if(natom.gt.namx) goto 999
      xc=xc+x
      yc=yc+y
      zc=zc+z
      xx(natom)=x 
      yy(natom)=y 
      zz(natom)=z 
       goto 1
 99   continue
c      close(55)
      xc=xc/float(natom)
      yc=yc/float(natom)
      zc=zc/float(natom)
 500  format(a)
 501  format(3f8.3)
 601  format('#',3f8.3,8x,f8.3,2i8)
c
	  d2max=0.0
	  iamax=0
      do 98 ia=1,natom
      x=xx(ia)
      y=yy(ia)
      z=zz(ia)
	  xr=x-xc
	  yr=y-yc
	  zr=z-zc
	  d2=xr**2+yr**2+zr**2
	  if(d2.gt.d2max) then
	  d2max=d2
	  iamax=ia
	  end if
 98   continue
      write(6,601) xc,yc,zc,sqrt(d2max),iamax,natom
c      open(66,file='ccenter.dat')
c      write(66,601) xc,yc,zc,sqrt(d2max),iamax,natom
c      close(66)
c
      call exit
 999  continue
      write(6,*) 'ERROR: no of atoms exceeds', namx
      call exit
      end

library(gplots)
library(cluster)
pdf(file="sims_parts.mat_2_h.pdf",width=9,height=9,paper="a4")
n=2
x=as.matrix(read.table("sims_parts.mat"))
x.dist=as.dist(sqrt(2-2*x))
title=expression(paste("Electrostatic Distance ",D[list(a,b)]==sqrt(2-2*SI[list(a,b)])))
x.clust=hclust(x.dist,method="ward.D2")
x.dend=as.dendrogram(x.clust)
x.clust.members=cutree(x.clust,k=n)
x.clust.coltypes=rainbow(n,s=0.4,start=0/6,end=5/6)
x.clust.colors=1:ncol(x)
order=order.dendrogram(x.dend)
for(count in 1:ncol(x)) {
   x.clust.colors[count]=x.clust.coltypes[x.clust.members[count]]
}
##### Snippet taken from SLmisc package to calculate constant colors for data
col=rainbow(512,s=0.8,v=1,start=0/6,end=5/6)
coln = col
margin=c(5,5)
#####
heatmap.2(as.matrix(x.dist),margins=c(14,14),col=coln,scale="none",distfun=function(n) n,Colv=x.dend,Rowv=x.dend,hclustfun=function(x) hclust(x.dist,method="ward.D2"),trace="none",revC=TRUE,symkey=FALSE,denscol="white",density.info='density',densadj=1,ColSideColors=x.clust.colors,main=expression(paste("Electrostatic Distance ",D[list(a,b)]==sqrt(2-2*SI[list(a,b)]))))
rm(x)
dev.off()

c.
c. usage pqr2qcd filename-pqr filename-qcd
c.
c pqr
cATOM      3  C   TYR     1         6.194    14.920    54.642   0.550   1.70           C
cATOM      9 HB2  CYS     1        39.813     3.622     0.014   0.000   0.00           H
c123456789012345678901234567890123456789012345678901234567890123456789012345
c         1         2         3         4         5         6         7         8         9
c qcd
cATOM     3 ASN  O      18.000  41.580  20.651  -0.550   1.800
c1234567890123456789012345678901234567890123456789012345678901
c         1         2         3         4         5         6
c(a4,i6,1x,a4,1x,a4,  1x,5f8.3)
c.
c. converts pqr format file to qcd format
c.
c. All atoms with 0 charge and 0 radius will be deleted
c.
c. A simple filter, it will read first 30 characters as 
c. if they are exactly in pdb and extract ATOM,na,aname,rname,chname,nr
c  The coordinates will be read in free format
c. 
c. To be improved to
c. 1. avoid failure while reading coordinates (f8.3 as in pdb 
c.                                             sometimes leaves no spaces)
c. 2. avoid failure while reading atom name/number part
c.
      character*80 s
      character*80 fpqr,fqcd
      character*4 aname,rname
c
      if(iargc().lt.2) then
      write(6,*) 'usage: pqr2qcd filename-pqr filename-qcd'
      call exit
      end if
c
      call getarg(1,fpqr)
      call getarg(2,fqcd)
c
      open(11,file=fpqr)
      open(31,file=fqcd)
 1    continue
      read(11,'(a)',end=91) s
      if((s(1:4).ne.'ATOM').and.(s(1:4).ne.'HETA')) goto 1
c
      read(s(31:80),*) x,y,z,q,r
      if((q.eq.0).and.(r.eq.0)) goto 1
c
      read(s(7:11),'(i5)') ia
      read(s(13:16),'(a)') aname
      if(s(13:13).eq.' ') read(s(14:17),'(a)') aname
      read(s(18:21),'(a)') rname
c
      write(31,503) ia,rname,aname,x,y,z,q,r
      goto 1
 91   continue
      close(11)
      close(31)
c
 503  format('ATOM',i6,1x,a4,1x,a4,1x,5f8.3)
 504  format(a,3f8.3,'  1.00  5.00')
c
      call exit
      end

c Reads kinemage and the filenames wich contain 
c protein names to be in different groups 
c and writes a kinemage with groups colured differently
c
      character*128 s,se,sa(999),namg(99),namp
      character*128 namgt,nampt
      character*9 col(19),colt
      data col/'magenta  ','cyan     ','green   ','orange    ',
     ,         'purple   ','yellow   ','red     ','yellowtint',
     ,         'brown    ','sky      ','gray    ','gold      ',
     ,         'sea      ','hotpink  ','bluetint' ,'greentint',
     ,         'pink     ','pinktint ','white   '/
c
      do i=1,128
      se(i:i)=' '
      end do
c
      ng=iargc()
      if(ng.lt.1) then
      write(6,*) 'usage: highlight_kin_groups fname1 fname2 ... ',
     ,'< in.kin > out.kin' 
      call exit
      end if
      do ig=1,ng
      call getarg(ig,namg(ig))
      end do
c
      np=0
 1    continue
      read(5,'(a)',end=99) s
      if(s(1:6).eq.'@balll') goto 91
      call slen(s,ns)
      write(6,'(a)') s(1:ns)
      goto 1
 91   continue
c. read coordinates
      np=0
 2    continue
      read(5,'(a)',end=92) s
      np=np+1
      sa(np)=s
      goto 2
 92   continue
c
      write(6,502)
      do ip=1,np
      s=sa(ip)
        call slen(s,ns)
        write(6,'(a)') s(1:ns)
      end do
 502  format('@balllist {ALL} color =white radius = 0.008')
c
      do ig=1,ng
      namgt=namg(ig)
      open(1,file=namgt)
      call slen(namgt,lnamgt)
      igc=ig
      if(igc.gt.19) igc=igc-19
      colt=col(ig)
      call slen(colt,lcolt)
      write(6,501) namgt(1:lnamgt),colt(1:lcolt)
 111  continue
      read(1,'(a)',end=112) namp
      call slen(namp,lnamp)
        do ip=1,np
        s=sa(ip)
        ll=lnamp+5
        if(s(6:ll).eq.namp(1:lnamp)) then
        call slen(s,ns)
        write(6,'(a)') s(1:ns)
        end if
        end do
      goto 111
 112  continue
      close(1)
      end do
 501  format('@balllist {',a,'} color =',a,' radius = 0.010')
c
 99   continue
      call exit
      end
      subroutine slen(s,ns)
      character*128 s
      do i=128,1,-1
      ns=i
      if(s(i:i).ne.' ') return
      end do
      return
      end

c------------------------------------------------------------------------
c  program grid2i      
c  version 4.23 (February 2000) 
c
c  Authors: R.R.Gabdoulline, R.C.Wade
c  Copyright (c) 2000
c  European Molecular Biology Laboratory
c  Meyerhofstr. 1, Postfach 10.2209
c  D-69012, Heidelberg, Germany
c
c  Please send your contact address to get information on updates and
c  new features to "gabdoull@EMBL-Heidelberg.DE". Questions will be 
c  answered as soon as possible.
c
c  Please obtain a license before using this software from 
c  "wade@EMBL-Heidelberg.DE".  Conditions of usage are as specified 
c  in the license.
c
c  References:
c     R.R. Gabdoulline, R.C. Wade.     
c  Brownian dynamics simulation of protein-protein diffusional encounter.
c  (1998) Methods, 14, 329-341. 
c------------------------------------------------------------------------
c
      integer im, jm, km, grdflg, mxgrd, one, kk
      parameter (mxgrd=110)
      integer iunit, iform
      character*72 title
      character*80 argum
      REAL h, ox, oy, oz, grid(mxgrd,mxgrd,mxgrd), scale
      REAL x0, y0, z0, x1, y1, z1, xmax, ymax, zmax, 
     &     xstart, ystart, zstart, xend, yend, zend
      REAL dum2, dum3, dum4, dum5, dum6, dum7, dum8
      integer idum2, idum3, idum4
      integer i, j, k, ounit
      character*80 newfle
      character*80 flnm
      character*4 stem
      character*1 string
c
      nargum=iargc()
      if(nargum.eq.0) then
      write(6,501)
      goto 999
      end if
 501  format(1x,'grid2i - convert map from GRID to InsightII format',/,
     ,       1x,'usage: grid2i A_or_B GRID_file Insight_file',/,
     ,       1x,'where: A_or_B is A for ascii and B for binary grid')
      call getarg(1,argum)      
      if(argum(1:1).eq.'A'.or.argum(1:1).eq.'a') then
        iform = 1
      else
        iform = 0
      endif
      call getarg(2,argum)
      flnm=argum
      call getarg(3,argum)
      newfle=argum
c
c Statement functions
c begin code
c
      write(6,100) 
100   format(1x,'CONVERT MAP FROM GRID TO INSIGHTII FORMAT')
c
c      write(6,110) 
c110   format(1x,'Is map in ascii (A) or binary (B) format?'
c     &            ,/,'(Answer: A or B)')
c      read(5,120) string
c120   format(a1)
c      if (string.eq.'A'.or.string.eq.'a') then
c        iform = 1
c      else if (string.eq.'B'.or.string.eq.'b') then
c        iform = 0
c      endif
c      write(6,130) 
c130   format(1x,'Enter grid map file name:')
c      read(5,135) flnm
c135   format(a)
      write(6,140) flnm
140   format(1x,'Grid input file :',a)
      iunit=11
      if ( iform .eq. 0 ) then
        open(unit=11, file = flnm, status = 'old', form='unformatted')
      else
        open(unit=11, file = flnm, status = 'old')
      endif
c
c      write(6,145) 
c145   format(1x,'Enter output INSIGHTII map file name:')
c      read(5,135) newfle
      write(6,148) newfle
148   format(1x,'Grid output file :',a)
c
       ounit=12
         open(12, file = newfle, status='new', form='unformatted')
c            call uhopen(12, newfle, 0)
c
c
	if ( iform .eq. 0 ) then
	  read (iunit) title, scale, dum2, grdflg, idum2,
     &              km, one, km, im, jm, km,
     &                   h ,      ox ,      oy ,      oz ,
     &          dum3, dum4, dum5, dum6, dum7, dum8, idum3, idum4
      elseif ( iform .eq. 1 ) then
        read (iunit,77) title, scale, dum2, grdflg, idum2,
     &                    km, one, km, im, jm, km,
     &                         h ,      ox ,      oy ,      oz ,
     &                    dum3, dum4, dum5, dum6, dum7,
     &                    dum8, idum3, idum4
       endif
c
c     do conversions (see grid2i)
      X0=ox+h
      Y0=oy+h
      Z0=oz+h
C**
      X1=ox+h*im
      Y1=oy+h*jm
      Z1=oz+h*km
C**
C**   FIND THE CORNER OF THE GRID WHICH IS FURTHEST FROM THE
C**   ORIGIN OF THE CARTESIAN COORDINATES.
C**
      XMAX = X0
      YMAX = Y0
      ZMAX = Z0
C**
      IF (ABS(X1).GT.ABS(X0)) XMAX=X1
      IF (ABS(Y1).GT.ABS(Y0)) YMAX=Y1
      IF (ABS(Z1).GT.ABS(Z0)) ZMAX=Z1
C**
      XSTART=X0/(ABS(XMAX))
      YSTART=Y0/(ABS(YMAX))
      ZSTART=Z0/(ABS(ZMAX))
C**
      XEND=X1/(ABS(XMAX))
      YEND=Y1/(ABS(YMAX))
      ZEND=Z1/(ABS(ZMAX))
C**
      write(ounit) title
      write(ounit) 0, 4, 0, 
     &            real(abs(xmax)), real(abs(ymax)), real(abs(zmax)),
     &            90.0, 90.0, 90.0,  
     &            xstart, xend, ystart, yend, zstart,zend,
     &            im -1, jm - 1, km - 1 
c
      if ( iform .eq. 0 ) then
        do  10  k = 1 , km
          read(iunit) kk, im, jm
          read(iunit) ( (grid(i,j,k), i=1,im ), j=1,jm )
   10   continue
      elseif ( iform .eq. 1 ) then
        do  20  k = 1 , km
          read(iunit,78) kk, im, jm
          read(iunit,79) ( ( grid(i,j,k), i=1,im), j=1,jm )
   20   continue
      endif
c
      gmx= grid(1,1,1)
      gmn= grid(1,1,1)
      do 51 i=1,im
      do 52 j=1,jm
      do 53 k=1,km
      if(grid(i,j,k).gt.gmx) gmx=grid(i,j,k)
      if(grid(i,j,k).lt.gmn) gmn=grid(i,j,k)
 53   continue
 52   continue
 51   continue
c
      write(6,502) im,jm,km,h,ox,oy,oz
 502  format(1x,'Read map, dimensions:',3i4,' spacing',f8.3,/,
     .       1x,'origin:',3f8.3)
      write(6,*) 'min-max:',gmn,gmx
c
      do  30  k = 1 , km
        do  30  j = 1 , jm
          write(ounit) (grid(i,j,k), i=1, im )
   30 continue
c
      close(iunit)
      close(ounit)
c
c
c               Format statements.
c
   77 format(a72/2e12.6,5i7/3i7,4e12.6/4e12.6/2e12.6,2i7)
   78 format(3i7)
   79 format( (6(1x,e12.6)) )
 999  continue
      end

#! /bin/sh

# To use this script, malign3d directory should be present
# also TEMPLATE.pdb file should be present in this directory 
# The program aligns the proteins to the target sequence. 

cd ../pdbs/
mkdir ../malign3d/pdbs/ # used to store new pdb files
rm -f ../malign3d/whatif.out # remove old log file
rm -f ../malign3d/out.pdb # remove old src file.
for I in `ls *.pdb`
do

    cp $I ../malign3d/in.pdb
    cd ../malign3d/
    echo "Running whatif on file $I ..."
    echo "-------------------\n FILE: $I \n" >>whatif.out
    whatif <../source/malign3d.whatif.in >>whatif.out 2>&1
    if [ ! -f out.pdb ]; then
	echo "WARNING: Calculations for $I were unsuccessful."
    else
	mv out.pdb "pdbs/$I"
    fi
    rm -f in.pdb
    cd ../pdbs/
done

rm in.pdb

echo "Finished."

#! /bin/sh -xv

# The program should create an unrooted tree which represents the relationships between the proteins. 
# For the program to work you should have neighbour / drawtree / fontfile / ps2pdf in source directory or in the path (in case of ps2pdf)

# As an argument either ../uhbd or ../grid should be given

DIR=$@
if [ -z DIR ]; then
echo "You should give a name of the directory with the sims.mat file"
exit 1
fi

# remove the old files
rm -f $DIR/infile $DIR/fontfile $DIR/plotfile $DIR/plotfile.ps ../pdbs/treefile ../pdbs/outfile ../pdbs/plotfile.pdf

# Do the stuff
echo "Converting the distance matrix into the Phylip file format..."
mat2phyl.pl < $DIR/sims.mat > $DIR/infile # convert the distance matrix into something digestable by phylip
cd $DIR
# ln -s ../source/fontfile fontfile
echo "Preparing treefile..."
../source/neighbour < ../source/neighbour.in # Creates 
echo "Drawing the tree..."
# sleep 3
cp ../source/fontfile fontfile # required by drawtree
# ../source/drawtree <../source/drawtree.in # Creates plotfile
../source/drawgram <../source/drawgram.in # Creates plotfile
echo "Changing the links..."
../source/addlinks.pl plotfile 'http://www.expasy.ch/cgi-bin/sprot-search-de?SEARCH=' > plotfile.ps
echo "Converting the file to .pdf file..."
ps2pdf plotfile.ps plotfile.pdf

echo "Done."
echo "The files plotfile.ps and plotfile.pdf contain the tree."

#! /bin/sh

# This program aligns the sequences to the TEMPLATE.pdb sequence, using modeller and modeller.2.in script.


cd ../pdbs
ls -1 *.pdb > names

# mkdir ../malign3d
cd ../malign3d/
mkdir pdbs
rm -f u.pdb modeller.log 


for I in `cat ../pdbs/names`
do
    echo "Now aligning $I ..."
    ln -s ../pdbs/$I u.pdb
    mod ../source/modeller.2.in
    if [ -f tmp.pdb ]; then
	mv tmp.pdb pdbs/$I
    else
	echo "Aligning $I was unsuccessful... "
    fi
    echo "---------\n$I\n\n" >> modeller.log
    cat ../source/modeller.2.in.log >> modeller.log
    rm -f u.pdb
done
echo "Done."

#!/bin/sh

# The program obtains the proper names from the Swiss-Prot database for the proteins, which file names in ../pdbs/pdbnames are based on accession numbers.
# The result is saved in propernames file.

cd ../pdbs/

rm propernames

for I in `cat pdbnames | cut -f1 -d.`
do
    LINK="http://www.expasy.ch/cgi-bin/sprot-search-de?S=1&T=1&SEARCH=$I"
    NAME=`wget -O - --quiet $LINK | perl -we '$f=0; while(<>){$f=1 if (/Entry name/); if ($f==1){if(/<b>(.*?)<\/b>/){print "$1";$f=0;}}}'`
    echo $NAME >> propernames

done

#!/bin/sh 

# The program will make surface with -2.5 & 2.5 from a protein .pdb file and electrostatic potential grid made by uhbd. 
# The potential grid should be present in ../uhdb folder and should have the name of the protein file with extension .grd. The pdb files should be located in ../pdbs folder. 
# The program uses insightII and grid2i65 from the uhbd package.

mkdir ../elec/

cd ../elec/

# Remove old stuff...
rm -f in.pdb in.ins outfile.wrl grid2i65.log insightII.log outfile.wrl

# Make dir for the converted insight files and convert them. 
#rm -f ins/* 

echo "Converting the uhbd file format into insightII file format..."
mkdir ins
for I in `cut -f1 -d. ../pdbs/names`
do
    echo "Now converting file $I.grd..."
    echo "B\n../uhbd/$I.grd\nins/$I.ins" | ../source/grid2i65 >>grid2i65.log # Convert the stuff
done


# Create the .wrl files that can be viewed with netscape.
rm -f wrl/*
mkdir wrl

echo "Running insightII..."
for I in `cut -f1 -d. ../pdbs/names`
do
    ln -s ../pdbs/$I.pdb in.pdb
    ln -s ins/$I.ins in.ins
    echo "Now running insightII on file $I..."
# A bug... insightII produces different output with and without -at (batch mode) switch on.
    insightII < ../source/insightII.electSurface.in >>insightII.log # Make the files
    mv outfile.wrl wrl/$I.wrl
    rm -f in.pdb in.ins
done

cat copyright.txt './mkkin.f' > tmp && mv tmp './mkkin.f'
cat copyright.txt './mkgridin.f' > tmp && mv tmp './mkgridin.f'
cat copyright.txt './mkuhbdin.f' > tmp && mv tmp './mkuhbdin.f'
cat copyright.txt './smNextopred.f' > tmp && mv tmp './smNextopred.f'
cat copyright.txt './2potsim_skin_parts.f' > tmp && mv tmp './2potsim_skin_parts.f'
cat copyright.txt './2potsim_skin_spheres.f' > tmp && mv tmp './2potsim_skin_spheres.f'
cat copyright.txt './whatif2uhbd.f' > tmp && mv tmp './whatif2uhbd.f'
cat copyright.txt './mkapbsin-apbs-ot-0.3.2.f' > tmp && mv tmp './mkapbsin-apbs-ot-0.3.2.f'
cat copyright.txt './2potsim_noskin.f' > tmp && mv tmp './2potsim_noskin.f'
cat copyright.txt './grid_asc2bin.f' > tmp && mv tmp './grid_asc2bin.f'
cat copyright.txt './n1potsim.f' > tmp && mv tmp './n1potsim.f'
cat copyright.txt './modeller2grin.f' > tmp && mv tmp './modeller2grin.f'
cat copyright.txt './qdipsim.f' > tmp && mv tmp './qdipsim.f'
cat copyright.txt './2potsim_skin_spheresU.f' > tmp && mv tmp './2potsim_skin_spheresU.f'
cat copyright.txt './2potsim_skin.f' > tmp && mv tmp './2potsim_skin.f'
cat copyright.txt './mkapbsin.f' > tmp && mv tmp './mkapbsin.f'
cat copyright.txt './2potsim_skin_spheresNN.f' > tmp && mv tmp './2potsim_skin_spheresNN.f'
cat copyright.txt './mkdismx.f' > tmp && mv tmp './mkdismx.f'
cat copyright.txt './ccenter.f' > tmp && mv tmp './ccenter.f'
cat copyright.txt './uhbd_asc2bin.f' > tmp && mv tmp './uhbd_asc2bin.f'
cat copyright.txt './nm1potsim.f' > tmp && mv tmp './nm1potsim.f'
cat copyright.txt './npotsim.f' > tmp && mv tmp './npotsim.f'

#!/bin/bash

export pipsa_wrk_dir=/home/richtesn/multipipsa/multipipsa/data/PH
export pipsa_distr_dir=/home/richtesn/multipipsa/multipipsa/data/pipsa
export apbs_exe=`which apbs`
export pdb2pqr_exe=`which pdb2pqr`

#!/bin/sh

# I am using modeller's command orient to alignt the sequences together... just quick hack to make it work...
# This command translates the MODEL so that its gravity center is at the 
# origin of the coordinate system and that the three principle axes of the 
# model's inertia ellipsoid correspond to the x, y, and z axes of the 
# coordinate system. It may even be used for approximate superposition if 
# molecules have a similar non-spherical shape. Information about the 
# principal axes is written to the log file. 

mkdir ../pdbs_orient

cd ../pdbs

for I in `ls *.pdb`
do
    echo "READ_MODEL FILE = '$I', MODEL_FORMAT = 'PDB'
ORIENT_MODEL
WRITE_MODEL FILE = '../pdbs_orient/$I'" > modeller.top

mod ../pdbs/modeller.top




done

#!/bin/bash
../../../bin/npotsim -pg ../../../bin/2potsim_skin -fn names -lg sims.log -pr 3 -sk 4
mv sims.log sims.log.conventional

../../../bin/npotsim -pg ../../../bin/2potsim_skin -fn names -lg sims.log -pr 3 -sk 4 -ma 4 && make -j 2 -k
